## GstVideoAlignment GstVideoAlignment — Support library for video operations |

## Functions

gboolean | gst_video_calculate_display_ratio ()
gboolean | gst_video_guess_framerate ()
void | (*GstVideoConvertSampleCallback) ()
GstSample * | gst_video_convert_sample ()
void | gst_video_convert_sample_async ()
void | gst_video_alignment_reset ()
GstEvent * | gst_video_event_new_still_frame ()
gboolean | gst_video_event_parse_still_frame ()
GstEvent * | gst_video_event_new_downstream_force_key_unit ()
gboolean | gst_video_event_parse_downstream_force_key_unit ()
GstEvent * | gst_video_event_new_upstream_force_key_unit ()
gboolean | gst_video_event_parse_upstream_force_key_unit ()
gboolean | gst_video_event_is_force_key_unit ()
void | (*GstVideoFormatUnpack) ()
void | (*GstVideoFormatPack) ()
#define | GST_VIDEO_FORMAT_INFO_FORMAT()
#define | GST_VIDEO_FORMAT_INFO_NAME()
#define | GST_VIDEO_FORMAT_INFO_FLAGS()
#define | GST_VIDEO_FORMAT_INFO_IS_YUV()
#define | GST_VIDEO_FORMAT_INFO_IS_RGB()
#define | GST_VIDEO_FORMAT_INFO_IS_GRAY()
#define | GST_VIDEO_FORMAT_INFO_HAS_ALPHA()
#define | GST_VIDEO_FORMAT_INFO_IS_LE()
#define | GST_VIDEO_FORMAT_INFO_HAS_PALETTE()
#define | GST_VIDEO_FORMAT_INFO_IS_COMPLEX()
#define | GST_VIDEO_FORMAT_INFO_BITS()
#define | GST_VIDEO_FORMAT_INFO_N_COMPONENTS()
#define | GST_VIDEO_FORMAT_INFO_SHIFT()
#define | GST_VIDEO_FORMAT_INFO_DEPTH()
#define | GST_VIDEO_FORMAT_INFO_PSTRIDE()
#define | GST_VIDEO_FORMAT_INFO_N_PLANES()
#define | GST_VIDEO_FORMAT_INFO_PLANE()
#define | GST_VIDEO_FORMAT_INFO_POFFSET()
#define | GST_VIDEO_FORMAT_INFO_W_SUB()
#define | GST_VIDEO_FORMAT_INFO_H_SUB()
#define | GST_VIDEO_SUB_SCALE()
#define | GST_VIDEO_FORMAT_INFO_SCALE_WIDTH()
#define | GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT()
#define | GST_VIDEO_FORMAT_INFO_DATA()
#define | GST_VIDEO_FORMAT_INFO_STRIDE()
#define | GST_VIDEO_FORMAT_INFO_OFFSET()
#define | GST_VIDEO_FORMAT_INFO_TILE_MODE()
#define | GST_VIDEO_FORMAT_INFO_TILE_WS()
#define | GST_VIDEO_FORMAT_INFO_TILE_HS()
#define | GST_VIDEO_FORMAT_INFO_IS_TILED()
GstVideoFormat | gst_video_format_from_masks ()
GstVideoFormat | gst_video_format_from_fourcc ()
guint32 | gst_video_format_to_fourcc ()
GstVideoFormat | gst_video_format_from_string ()
const gchar * | gst_video_format_to_string ()
gconstpointer | gst_video_format_get_palette ()
const GstVideoFormatInfo * | gst_video_format_get_info ()
#define | GST_VIDEO_CAPS_MAKE()
#define | GST_VIDEO_CAPS_MAKE_WITH_FEATURES()
void | gst_video_color_range_offsets ()
gboolean | gst_video_color_matrix_get_Kr_Kb ()
gdouble | gst_video_color_transfer_decode ()
gdouble | gst_video_color_transfer_encode ()
gboolean | gst_video_colorimetry_matches ()
gboolean | gst_video_colorimetry_is_equal ()
gboolean | gst_video_colorimetry_from_string ()
gchar * | gst_video_colorimetry_to_string ()
#define | GST_VIDEO_INFO_FORMAT()
#define | GST_VIDEO_INFO_NAME()
#define | GST_VIDEO_INFO_IS_YUV()
#define | GST_VIDEO_INFO_IS_RGB()
#define | GST_VIDEO_INFO_IS_GRAY()
#define | GST_VIDEO_INFO_HAS_ALPHA()
#define | GST_VIDEO_INFO_INTERLACE_MODE()
#define | GST_VIDEO_INFO_IS_INTERLACED()
#define | GST_VIDEO_INFO_FIELD_ORDER()
#define | GST_VIDEO_INFO_FLAGS()
#define | GST_VIDEO_INFO_WIDTH()
#define | GST_VIDEO_INFO_HEIGHT()
#define | GST_VIDEO_INFO_SIZE()
#define | GST_VIDEO_INFO_VIEWS()
#define | GST_VIDEO_INFO_PAR_N()
#define | GST_VIDEO_INFO_PAR_D()
#define | GST_VIDEO_INFO_FPS_N()
#define | GST_VIDEO_INFO_FPS_D()
#define | GST_VIDEO_INFO_FLAG_IS_SET()
#define | GST_VIDEO_INFO_FLAG_SET()
#define | GST_VIDEO_INFO_FLAG_UNSET()
#define | GST_VIDEO_INFO_N_PLANES()
#define | GST_VIDEO_INFO_PLANE_OFFSET()
#define | GST_VIDEO_INFO_PLANE_STRIDE()
#define | GST_VIDEO_INFO_N_COMPONENTS()
#define | GST_VIDEO_INFO_COMP_DEPTH()
#define | GST_VIDEO_INFO_COMP_DATA()
#define | GST_VIDEO_INFO_COMP_OFFSET()
#define | GST_VIDEO_INFO_COMP_STRIDE()
#define | GST_VIDEO_INFO_COMP_WIDTH()
#define | GST_VIDEO_INFO_COMP_HEIGHT()
#define | GST_VIDEO_INFO_COMP_PLANE()
#define | GST_VIDEO_INFO_COMP_PSTRIDE()
#define | GST_VIDEO_INFO_COMP_POFFSET()
#define | GST_VIDEO_INFO_CHROMA_SITE()
#define | GST_VIDEO_INFO_COLORIMETRY()
#define | GST_VIDEO_INFO_MULTIVIEW_FLAGS()
#define | GST_VIDEO_INFO_MULTIVIEW_MODE()
void | gst_video_info_init ()
GstVideoInfo * | gst_video_info_new ()
GstVideoInfo * | gst_video_info_copy ()
void | gst_video_info_free ()
gboolean | gst_video_info_set_format ()
gboolean | gst_video_info_from_caps ()
GstCaps * | gst_video_info_to_caps ()
gboolean | gst_video_info_convert ()
gboolean | gst_video_info_is_equal ()
gboolean | gst_video_info_align ()
GstVideoInterlaceMode | gst_video_interlace_mode_from_string ()
const gchar * | gst_video_interlace_mode_to_string ()
GstVideoFieldOrder | gst_video_field_order_from_string ()
const gchar * | gst_video_field_order_to_string ()
gboolean | gst_video_frame_map_id ()
gboolean | gst_video_frame_map ()
void | gst_video_frame_unmap ()
gboolean | gst_video_frame_copy ()
gboolean | gst_video_frame_copy_plane ()
#define | GST_VIDEO_FRAME_FORMAT()
#define | GST_VIDEO_FRAME_WIDTH()
#define | GST_VIDEO_FRAME_HEIGHT()
#define | GST_VIDEO_FRAME_SIZE()
#define | GST_VIDEO_FRAME_FLAGS()
#define | GST_VIDEO_FRAME_FLAG_IS_SET()
#define | GST_VIDEO_FRAME_IS_INTERLACED()
#define | GST_VIDEO_FRAME_IS_TFF()
#define | GST_VIDEO_FRAME_IS_RFF()
#define | GST_VIDEO_FRAME_IS_ONEFIELD()
#define | GST_VIDEO_FRAME_N_PLANES()
#define | GST_VIDEO_FRAME_PLANE_DATA()
#define | GST_VIDEO_FRAME_PLANE_OFFSET()
#define | GST_VIDEO_FRAME_PLANE_STRIDE()
#define | GST_VIDEO_FRAME_N_COMPONENTS()
#define | GST_VIDEO_FRAME_COMP_DEPTH()
#define | GST_VIDEO_FRAME_COMP_DATA()
#define | GST_VIDEO_FRAME_COMP_STRIDE()
#define | GST_VIDEO_FRAME_COMP_OFFSET()
#define | GST_VIDEO_FRAME_COMP_WIDTH()
#define | GST_VIDEO_FRAME_COMP_HEIGHT()
#define | GST_VIDEO_FRAME_COMP_PLANE()
#define | GST_VIDEO_FRAME_COMP_PSTRIDE()
#define | GST_VIDEO_FRAME_COMP_POFFSET()
guint | gst_video_tile_get_index ()
#define | GST_VIDEO_TILE_MAKE_MODE()
#define | GST_VIDEO_TILE_MODE_TYPE()
#define | GST_VIDEO_TILE_MODE_IS_INDEXED()
#define | GST_VIDEO_TILE_MAKE_STRIDE()
#define | GST_VIDEO_TILE_X_TILES()
#define | GST_VIDEO_TILE_Y_TILES()
gboolean | gst_video_blend ()
void | gst_video_blend_scale_linear_RGBA ()
GstVideoConverter * | gst_video_converter_new ()
void | gst_video_converter_free ()
const GstStructure * | gst_video_converter_get_config ()
gboolean | gst_video_converter_set_config ()
void | gst_video_converter_frame ()
const GValue * | gst_video_multiview_get_mono_modes ()
const GValue * | gst_video_multiview_get_unpacked_modes ()
const GValue * | gst_video_multiview_get_doubled_height_modes ()
const GValue * | gst_video_multiview_get_doubled_size_modes ()
const GValue * | gst_video_multiview_get_doubled_width_modes ()
GstVideoMultiviewMode | gst_video_multiview_mode_from_caps_string ()
const gchar * | gst_video_multiview_mode_to_caps_string ()
gboolean | gst_video_multiview_guess_half_aspect ()
void | gst_video_multiview_video_info_change_mode ()
GstVideoTimeCode * | gst_video_time_code_new ()
GstVideoTimeCode * | gst_video_time_code_new_empty ()
void | gst_video_time_code_free ()
GstVideoTimeCode * | gst_video_time_code_copy ()
void | gst_video_time_code_init ()
void | gst_video_time_code_init_from_date_time ()
void | gst_video_time_code_clear ()
gboolean | gst_video_time_code_is_valid ()
gint | gst_video_time_code_compare ()
void | gst_video_time_code_increment_frame ()
void | gst_video_time_code_add_frames ()
guint64 | gst_video_time_code_frames_since_daily_jam ()
guint64 | gst_video_time_code_nsec_since_daily_jam ()
GDateTime * | gst_video_time_code_to_date_time ()
gchar * | gst_video_time_code_to_string ()
GstVideoTimeCode * | gst_video_time_code_add_interval ()
GstVideoTimeCode * | gst_video_time_code_new_from_string ()
GstVideoTimeCode * | gst_video_time_code_new_from_date_time ()
GstVideoTimeCodeInterval * | gst_video_time_code_interval_new ()
GstVideoTimeCodeInterval * | gst_video_time_code_interval_new_from_string ()
void | gst_video_time_code_interval_init ()
void | gst_video_time_code_interval_clear ()
GstVideoTimeCodeInterval * | gst_video_time_code_interval_copy ()
void | gst_video_time_code_interval_free ()

## Types and Values

struct | GstVideoAlignment
#define | GST_META_TAG_VIDEO_STR
#define | GST_META_TAG_VIDEO_ORIENTATION_STR
#define | GST_META_TAG_VIDEO_SIZE_STR
#define | GST_META_TAG_VIDEO_COLORSPACE_STR
enum | GstVideoOrientationMethod
enum | GstVideoFormat
#define | GST_VIDEO_MAX_PLANES
#define | GST_VIDEO_MAX_COMPONENTS
struct | GstVideoFormatInfo
enum | GstVideoFormatFlags
enum | GstVideoPackFlags
#define | GST_VIDEO_SIZE_RANGE
#define | GST_VIDEO_FPS_RANGE
#define | GST_VIDEO_FORMATS_ALL
enum | GstVideoColorRange
enum | GstVideoColorMatrix
enum | GstVideoColorPrimaries
enum | GstVideoTransferFunction
| GstVideoColorimetry
#define | GST_VIDEO_COLORIMETRY_BT2020
#define | GST_VIDEO_COLORIMETRY_BT601
#define | GST_VIDEO_COLORIMETRY_BT709
#define | GST_VIDEO_COLORIMETRY_SMPTE240M
#define | GST_VIDEO_COLORIMETRY_SRGB
struct | GstVideoInfo
enum | GstVideoInterlaceMode
enum | GstVideoFieldOrder
enum | GstVideoMultiviewMode
enum | GstVideoMultiviewFramePacking
enum | GstVideoMultiviewFlags
enum | GstVideoFlags
struct | GstVideoFrame
enum | GstVideoFrameFlags
enum | GstVideoFrameMapFlags
enum | GstVideoBufferFlags
enum | GstVideoTileType
enum | GstVideoTileMode
| GstVideoConverter
enum | GstVideoAlphaMode
enum | GstVideoChromaMode
enum | GstVideoGammaMode
enum | GstVideoMatrixMode
enum | GstVideoPrimariesMode
#define | GST_VIDEO_CONVERTER_OPT_ALPHA_MODE
#define | GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE
#define | GST_VIDEO_CONVERTER_OPT_BORDER_ARGB
#define | GST_VIDEO_CONVERTER_OPT_CHROMA_MODE
#define | GST_VIDEO_CONVERTER_OPT_CHROMA_RESAMPLER_METHOD
#define | GST_VIDEO_CONVERTER_OPT_DEST_HEIGHT
#define | GST_VIDEO_CONVERTER_OPT_DEST_WIDTH
#define | GST_VIDEO_CONVERTER_OPT_DEST_X
#define | GST_VIDEO_CONVERTER_OPT_DEST_Y
#define | GST_VIDEO_CONVERTER_OPT_DITHER_METHOD
#define | GST_VIDEO_CONVERTER_OPT_DITHER_QUANTIZATION
#define | GST_VIDEO_CONVERTER_OPT_FILL_BORDER
#define | GST_VIDEO_CONVERTER_OPT_GAMMA_MODE
#define | GST_VIDEO_CONVERTER_OPT_MATRIX_MODE
#define | GST_VIDEO_CONVERTER_OPT_PRIMARIES_MODE
#define | GST_VIDEO_CONVERTER_OPT_RESAMPLER_METHOD
#define | GST_VIDEO_CONVERTER_OPT_RESAMPLER_TAPS
#define | GST_VIDEO_CONVERTER_OPT_SRC_HEIGHT
#define | GST_VIDEO_CONVERTER_OPT_SRC_WIDTH
#define | GST_VIDEO_CONVERTER_OPT_SRC_X
#define | GST_VIDEO_CONVERTER_OPT_SRC_Y
#define | GST_VIDEO_MULTIVIEW_MAX_FRAME_PACKING
struct | GstVideoTimeCode
struct | GstVideoTimeCodeConfig
enum | GstVideoTimeCodeFlags
struct | GstVideoTimeCodeInterval

## Includes

    #include <gst/video/video.h>

## Description

This library contains some helper functions and includes the videosink and videofilter base classes.

## Functions

### gst_video_calculate_display_ratio ()

    gboolean
    gst_video_calculate_display_ratio (guint *dar_n,
                                       guint *dar_d,
                                       guint video_width,
                                       guint video_height,
                                       guint video_par_n,
                                       guint video_par_d,
                                       guint display_par_n,
                                       guint display_par_d);

Given the Pixel Aspect Ratio and size of an input video frame, and the pixel aspect ratio of the intended display device, calculates the actual display ratio the video will be rendered with.

#### Parameters

dar_n | Numerator of the calculated display_ratio. | [out]
dar_d | Denominator of the calculated display_ratio. | [out]
video_width | Width of the video frame in pixels |
video_height | Height of the video frame in pixels |
video_par_n | Numerator of the pixel aspect ratio of the input video. |
video_par_d | Denominator of the pixel aspect ratio of the input video. |
display_par_n | Numerator of the pixel aspect ratio of the display device |
display_par_d | Denominator of the pixel aspect ratio of the display device |

#### Returns

A boolean indicating success and a calculated Display Ratio in the dar_n and dar_d parameters. The return value is FALSE in the case of integer overflow or other error.

### gst_video_guess_framerate ()

    gboolean
    gst_video_guess_framerate (GstClockTime duration,
                               gint *dest_n,
                               gint *dest_d);

Given the nominal duration of one video frame, this function will check some standard framerates for a close match (within 0.1%) and return one if possible,

It will calculate an arbitrary framerate if no close match was found, and return `FALSE`.

It returns `FALSE` if a duration of 0 is passed.

#### Parameters

duration | Nominal duration of one frame |
dest_n | Numerator of the calculated framerate. | [out][allow-none]
dest_d | Denominator of the calculated framerate. | [out][allow-none]

#### Returns

`TRUE` if a close "standard" framerate was recognised, and `FALSE` otherwise.

Since: 1.6

### GstVideoConvertSampleCallback ()

    void
    (*GstVideoConvertSampleCallback) (GstSample *sample,
                                      GError *error,
                                      gpointer user_data);

### gst_video_convert_sample ()

    GstSample *
    gst_video_convert_sample (GstSample *sample,
                              const GstCaps *to_caps,
                              GstClockTime timeout,
                              GError **error);

Converts a raw video buffer into the specified output caps.

The output caps can be any raw video formats or any image formats (jpeg, png, ...).

The width, height and pixel-aspect-ratio can also be specified in the output caps.

#### Parameters

sample | a GstSample |
to_caps | the GstCaps to convert to |
timeout | the maximum amount of time allowed for the processing. |
error | pointer to a GError. Can be `NULL`. |

#### Returns

The converted GstSample, or `NULL` if an error happened (in which case `err` will point to the GError).

### gst_video_convert_sample_async ()

    void
    gst_video_convert_sample_async (GstSample *sample,
                                    const GstCaps *to_caps,
                                    GstClockTime timeout,
                                    GstVideoConvertSampleCallback callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy_notify);

Converts a raw video buffer into the specified output caps.

The output caps can be any raw video formats or any image formats (jpeg, png, ...).

The width, height and pixel-aspect-ratio can also be specified in the output caps.

`callback` will be called after conversion, when an error occured or if conversion didn't finish after `timeout` . `callback` will always be called from the thread default `GMainContext`, see `g_main_context_get_thread_default()`. If GLib before 2.22 is used, this will always be the global default main context.

`destroy_notify` will be called after the callback was called and `user_data` is not needed anymore.

#### Parameters

sample | a GstSample |
to_caps | the GstCaps to convert to |
timeout | the maximum amount of time allowed for the processing. |
callback | `GstVideoConvertSampleCallback` that will be called after conversion. |
user_data | extra data that will be passed to the `callback` |
destroy_notify | `GDestroyNotify` to be called after `user_data` is not needed anymore |

### gst_video_alignment_reset ()

    void
    gst_video_alignment_reset (GstVideoAlignment *align);

Set `align` to its default values with no padding and no alignment.

#### Parameters

align | a GstVideoAlignment |

### gst_video_event_new_still_frame ()

    GstEvent *
    gst_video_event_new_still_frame (gboolean in_still);

Creates a new Still Frame event. If `in_still` is `TRUE`, then the event represents the start of a still frame sequence. If it is `FALSE`, then the event ends a still frame sequence.

To parse an event created by `gst_video_event_new_still_frame()` use `gst_video_event_parse_still_frame()`.

#### Parameters

in_still | boolean value for the still-frame state of the event. |

#### Returns

The new GstEvent

### gst_video_event_parse_still_frame ()

    gboolean
    gst_video_event_parse_still_frame (GstEvent *event,
                                       gboolean *in_still);

Parse a GstEvent, identify if it is a Still Frame event, and return the still-frame state from the event if it is. If the event represents the start of a still frame, the in_still variable will be set to TRUE, otherwise FALSE. It is OK to pass NULL for the in_still variable order to just check whether the event is a valid still-frame event.

Create a still frame event using `gst_video_event_new_still_frame()`

#### Parameters

event | A GstEvent to parse |
in_still | A boolean to receive the still-frame status from the event, or NULL. | [out]

#### Returns

`TRUE` if the event is a valid still-frame event. `FALSE` if not

### gst_video_event_new_downstream_force_key_unit ()

    GstEvent *
    gst_video_event_new_downstream_force_key_unit
                                   (GstClockTime timestamp,
                                    GstClockTime stream_time,
                                    GstClockTime running_time,
                                    gboolean all_headers,
                                    guint count);

Creates a new downstream force key unit event. A downstream force key unit event can be sent down the pipeline to request downstream elements to produce a key unit. A downstream force key unit event must also be sent when handling an upstream force key unit event to notify downstream that the latter has been handled.

To parse an event created by `gst_video_event_new_downstream_force_key_unit()` use `gst_video_event_parse_downstream_force_key_unit()`.

#### Parameters

timestamp | the timestamp of the buffer that starts a new key unit |
stream_time | the stream_time of the buffer that starts a new key unit |
running_time | the running_time of the buffer that starts a new key unit |
all_headers | `TRUE` to produce headers when starting a new key unit |
count | integer that can be used to number key units |

#### Returns

The new GstEvent

### gst_video_event_parse_downstream_force_key_unit ()

    gboolean
    gst_video_event_parse_downstream_force_key_unit
                                   (GstEvent *event,
                                    GstClockTime *timestamp,
                                    GstClockTime *stream_time,
                                    GstClockTime *running_time,
                                    gboolean *all_headers,
                                    guint *count);

Get timestamp, stream-time, running-time, all-headers and count in the force key unit event. See `gst_video_event_new_downstream_force_key_unit()` for a full description of the downstream force key unit event.

`running_time` will be adjusted for any pad offsets of pads it was passing through.

#### Parameters

event | A GstEvent to parse |
timestamp | A pointer to the timestamp in the event. | [out]
stream_time | A pointer to the stream-time in the event. | [out]
running_time | A pointer to the running-time in the event. | [out]
all_headers | A pointer to the all_headers flag in the event. | [out]
count | A pointer to the count field of the event. | [out]

#### Returns

`TRUE` if the event is a valid downstream force key unit event.

### gst_video_event_new_upstream_force_key_unit ()

    GstEvent *
    gst_video_event_new_upstream_force_key_unit
                                   (GstClockTime running_time,
                                    gboolean all_headers,
                                    guint count);

Creates a new upstream force key unit event. An upstream force key unit event can be sent to request upstream elements to produce a key unit.

`running_time` can be set to request a new key unit at a specific running_time. If set to GST_CLOCK_TIME_NONE, upstream elements will produce a new key unit as soon as possible.

To parse an event created by `gst_video_event_new_downstream_force_key_unit()` use `gst_video_event_parse_downstream_force_key_unit()`.

#### Parameters

running_time | the running_time at which a new key unit should be produced |
all_headers | `TRUE` to produce headers when starting a new key unit |
count | integer that can be used to number key units |

#### Returns

The new GstEvent

### gst_video_event_parse_upstream_force_key_unit ()

    gboolean
    gst_video_event_parse_upstream_force_key_unit
                                   (GstEvent *event,
                                    GstClockTime *running_time,
                                    gboolean *all_headers,
                                    guint *count);

Get running-time, all-headers and count in the force key unit event. See `gst_video_event_new_upstream_force_key_unit()` for a full description of the upstream force key unit event.

Create an upstream force key unit event using `gst_video_event_new_upstream_force_key_unit()`

`running_time` will be adjusted for any pad offsets of pads it was passing through.

#### Parameters

event | A GstEvent to parse |
running_time | A pointer to the running_time in the event. | [out]
all_headers | A pointer to the all_headers flag in the event. | [out]
count | A pointer to the count field in the event. | [out]

#### Returns

`TRUE` if the event is a valid upstream force-key-unit event. `FALSE` if not

### gst_video_event_is_force_key_unit ()

    gboolean
    gst_video_event_is_force_key_unit (GstEvent *event);

Checks if an event is a force key unit event. Returns true for both upstream and downstream force key unit events.

#### Parameters

event | A GstEvent to check |

#### Returns

`TRUE` if the event is a valid force key unit event

### GstVideoFormatUnpack ()

    void
    (*GstVideoFormatUnpack) (const GstVideoFormatInfo *info,
                             GstVideoPackFlags flags,
                             gpointer dest,
                             const gpointer data[GST_VIDEO_MAX_PLANES],
                             const gint stride[GST_VIDEO_MAX_PLANES],
                             gint x,
                             gint y,
                             gint width);

Unpacks `width` pixels from the given planes and strides containing data of format `info` . The pixels will be unpacked into `dest` with each component interleaved as per `info` 's unpack_format, which will usually be one of GST_VIDEO_FORMAT_ARGB, GST_VIDEO_FORMAT_AYUV, GST_VIDEO_FORMAT_ARGB64 or GST_VIDEO_FORMAT_AYUV64 depending on the format to unpack. `dest` should at least be big enough to hold `width` * bytes_per_pixel bytes where bytes_per_pixel relates to the unpack format and will usually be either 4 or 8 depending on the unpack format. bytes_per_pixel will be the same as the pixel stride for plane 0 for the above formats.

For subsampled formats, the components will be duplicated in the destination array. Reconstruction of the missing components can be performed in a separate step after unpacking.

#### Parameters

info | a GstVideoFormatInfo |
flags | flags to control the unpacking |
dest | a destination array |
data | pointers to the data planes |
stride | strides of the planes |
x | the x position in the image to start from |
y | the y position in the image to start from |
width | the amount of pixels to unpack. |

### GstVideoFormatPack ()

    void
    (*GstVideoFormatPack) (const GstVideoFormatInfo *info,
                           GstVideoPackFlags flags,
                           const gpointer src,
                           gint sstride,
                           gpointer data[GST_VIDEO_MAX_PLANES],
                           const gint stride[GST_VIDEO_MAX_PLANES],
                           GstVideoChromaSite chroma_site,
                           gint y,
                           gint width);

Packs `width` pixels from `src` to the given planes and strides in the format `info` . The pixels from source have each component interleaved and will be packed into the planes in `data` .

This function operates on pack_lines lines, meaning that `src` should contain at least pack_lines lines with a stride of `sstride` and `y` should be a multiple of pack_lines.

Subsampled formats will use the horizontally and vertically cosited component from the source. Subsampling should be performed before packing.

Because this function does not have a x coordinate, it is not possible to pack pixels starting from an unaligned position. For tiled images this means that packing should start from a tile coordinate. For subsampled formats this means that a complete pixel needs to be packed.

#### Parameters

info | a GstVideoFormatInfo |
flags | flags to control the packing |
src | a source array |
sstride | the source array stride |
data | pointers to the destination data planes |
stride | strides of the destination planes |
chroma_site | the chroma siting of the target when subsampled (not used) |
y | the y position in the image to pack to |
width | the amount of pixels to pack. |

### GST_VIDEO_FORMAT_INFO_FORMAT()

    #define GST_VIDEO_FORMAT_INFO_FORMAT(info)       ((info)->format)

### GST_VIDEO_FORMAT_INFO_NAME()

    #define GST_VIDEO_FORMAT_INFO_NAME(info)         ((info)->name)

### GST_VIDEO_FORMAT_INFO_FLAGS()

    #define GST_VIDEO_FORMAT_INFO_FLAGS(info)        ((info)->flags)

### GST_VIDEO_FORMAT_INFO_IS_YUV()

    #define GST_VIDEO_FORMAT_INFO_IS_YUV(info)       ((info)->flags & GST_VIDEO_FORMAT_FLAG_YUV)

### GST_VIDEO_FORMAT_INFO_IS_RGB()

    #define GST_VIDEO_FORMAT_INFO_IS_RGB(info)       ((info)->flags & GST_VIDEO_FORMAT_FLAG_RGB)

### GST_VIDEO_FORMAT_INFO_IS_GRAY()

    #define GST_VIDEO_FORMAT_INFO_IS_GRAY(info)      ((info)->flags & GST_VIDEO_FORMAT_FLAG_GRAY)

### GST_VIDEO_FORMAT_INFO_HAS_ALPHA()

    #define GST_VIDEO_FORMAT_INFO_HAS_ALPHA(info)    ((info)->flags & GST_VIDEO_FORMAT_FLAG_ALPHA)

### GST_VIDEO_FORMAT_INFO_IS_LE()

    #define GST_VIDEO_FORMAT_INFO_IS_LE(info)        ((info)->flags & GST_VIDEO_FORMAT_FLAG_LE)

### GST_VIDEO_FORMAT_INFO_HAS_PALETTE()

    #define GST_VIDEO_FORMAT_INFO_HAS_PALETTE(info)  ((info)->flags & GST_VIDEO_FORMAT_FLAG_PALETTE)

### GST_VIDEO_FORMAT_INFO_IS_COMPLEX()

    #define GST_VIDEO_FORMAT_INFO_IS_COMPLEX(info)   ((info)->flags & GST_VIDEO_FORMAT_FLAG_COMPLEX)

### GST_VIDEO_FORMAT_INFO_BITS()

    #define GST_VIDEO_FORMAT_INFO_BITS(info)         ((info)->bits)

### GST_VIDEO_FORMAT_INFO_N_COMPONENTS()

    #define GST_VIDEO_FORMAT_INFO_N_COMPONENTS(info) ((info)->n_components)

### GST_VIDEO_FORMAT_INFO_SHIFT()

    #define GST_VIDEO_FORMAT_INFO_SHIFT(info,c)      ((info)->shift[c])

### GST_VIDEO_FORMAT_INFO_DEPTH()

    #define GST_VIDEO_FORMAT_INFO_DEPTH(info,c)      ((info)->depth[c])

### GST_VIDEO_FORMAT_INFO_PSTRIDE()

    #define GST_VIDEO_FORMAT_INFO_PSTRIDE(info,c)    ((info)->pixel_stride[c])

pixel stride for the given component. This is the amount of bytes to the pixel immediately to the right, so basically bytes from one pixel to the next. When bits < 8, the stride is expressed in bits.

Examples: for 24-bit RGB, the pixel stride would be 3 bytes, while it would be 4 bytes for RGBx or ARGB, and 8 bytes for ARGB64 or AYUV64. For planar formats such as I420 the pixel stride is usually 1. For YUY2 it would be 2 bytes.

#### Parameters

info | a GstVideoFormatInfo |
c | the component index |

### GST_VIDEO_FORMAT_INFO_N_PLANES()

    #define GST_VIDEO_FORMAT_INFO_N_PLANES(info)     ((info)->n_planes)

Number of planes. This is the number of planes the pixel layout is organized in in memory. The number of planes can be less than the number of components (e.g. Y,U,V,A or R, G, B, A) when multiple components are packed into one plane.

Examples: RGB/RGBx/RGBA: 1 plane, 3/3/4 components; I420: 3 planes, 3 components; NV21/NV12: 2 planes, 3 components.

#### Parameters

info | a GstVideoFormatInfo |

### GST_VIDEO_FORMAT_INFO_PLANE()

    #define GST_VIDEO_FORMAT_INFO_PLANE(info,c)      ((info)->plane[c])

Plane number where the given component can be found. A plane may contain data for multiple components.

#### Parameters

info | a GstVideoFormatInfo |
c | the component index |

### GST_VIDEO_FORMAT_INFO_POFFSET()

    #define GST_VIDEO_FORMAT_INFO_POFFSET(info,c)    ((info)->poffset[c])

### GST_VIDEO_FORMAT_INFO_W_SUB()

    #define GST_VIDEO_FORMAT_INFO_W_SUB(info,c)      ((info)->w_sub[c])

### GST_VIDEO_FORMAT_INFO_H_SUB()

    #define GST_VIDEO_FORMAT_INFO_H_SUB(info,c)      ((info)->h_sub[c])

### GST_VIDEO_SUB_SCALE()

    #define GST_VIDEO_SUB_SCALE(scale,val)   (-((-((gint)(val)))>>(scale)))

### GST_VIDEO_FORMAT_INFO_SCALE_WIDTH()

    #define GST_VIDEO_FORMAT_INFO_SCALE_WIDTH(info,c,w)  GST_VIDEO_SUB_SCALE ((info)->w_sub[c],(w))

### GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT()

    #define GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT(info,c,h) GST_VIDEO_SUB_SCALE ((info)->h_sub[c],(h))

### GST_VIDEO_FORMAT_INFO_DATA()

    #define             GST_VIDEO_FORMAT_INFO_DATA(info,planes,comp)

### GST_VIDEO_FORMAT_INFO_STRIDE()

    #define GST_VIDEO_FORMAT_INFO_STRIDE(info,strides,comp) ((strides)[(info)->plane[comp]])

Row stride in bytes, that is number of bytes from the first pixel component of a row to the first pixel component in the next row. This might include some row padding (memory not actually used for anything, to make sure the beginning of the next row is aligned in a particular way).

#### Parameters

info | a GstVideoFormatInfo |
strides | an array of strides |
comp | the component index |

### GST_VIDEO_FORMAT_INFO_OFFSET()

    #define             GST_VIDEO_FORMAT_INFO_OFFSET(info,offsets,comp)

### GST_VIDEO_FORMAT_INFO_TILE_MODE()

    #define GST_VIDEO_FORMAT_INFO_TILE_MODE(info) ((info)->tile_mode)

### GST_VIDEO_FORMAT_INFO_TILE_WS()

    #define GST_VIDEO_FORMAT_INFO_TILE_WS(info) ((info)->tile_ws)

### GST_VIDEO_FORMAT_INFO_TILE_HS()

    #define GST_VIDEO_FORMAT_INFO_TILE_HS(info) ((info)->tile_hs)

### GST_VIDEO_FORMAT_INFO_IS_TILED()

    #define GST_VIDEO_FORMAT_INFO_IS_TILED(info)     ((info)->flags & GST_VIDEO_FORMAT_FLAG_TILED)

### gst_video_format_from_masks ()

    GstVideoFormat
    gst_video_format_from_masks (gint depth,
                                 gint bpp,
                                 gint endianness,
                                 guint red_mask,
                                 guint green_mask,
                                 guint blue_mask,
                                 guint alpha_mask);

Find the GstVideoFormat for the given parameters.

#### Parameters

depth | the amount of bits used for a pixel |
bpp | the amount of bits used to store a pixel. This value is bigger than `depth` |
endianness | the endianness of the masks, G_LITTLE_ENDIAN or G_BIG_ENDIAN |
red_mask | the red mask |
green_mask | the green mask |
blue_mask | the blue mask |
alpha_mask | the alpha mask, or 0 if no alpha mask |

#### Returns

a GstVideoFormat or GST_VIDEO_FORMAT_UNKNOWN when the parameters to not specify a known format.

### gst_video_format_from_fourcc ()

    GstVideoFormat
    gst_video_format_from_fourcc (guint32 fourcc);

Converts a FOURCC value into the corresponding GstVideoFormat. If the FOURCC cannot be represented by GstVideoFormat, GST_VIDEO_FORMAT_UNKNOWN is returned.

#### Parameters

fourcc | a FOURCC value representing raw YUV video |

#### Returns

the GstVideoFormat describing the FOURCC value

### gst_video_format_to_fourcc ()

    guint32
    gst_video_format_to_fourcc (GstVideoFormat format);

Converts a GstVideoFormat value into the corresponding FOURCC. Only a few YUV formats have corresponding FOURCC values. If `format` has no corresponding FOURCC value, 0 is returned.

#### Parameters

format | a GstVideoFormat video format |

#### Returns

the FOURCC corresponding to `format`

### gst_video_format_from_string ()

    GstVideoFormat
    gst_video_format_from_string (const gchar *format);

Convert the `format` string to its GstVideoFormat.

#### Parameters

format | a format string |

#### Returns

the GstVideoFormat for `format` or GST_VIDEO_FORMAT_UNKNOWN when the string is not a known format.

### gst_video_format_to_string ()

    const gchar *
    gst_video_format_to_string (GstVideoFormat format);

Returns a string containing a descriptive name for the GstVideoFormat if there is one, or NULL otherwise.

#### Parameters

format | a GstVideoFormat video format |

#### Returns

the name corresponding to `format`

### gst_video_format_get_palette ()

    gconstpointer
    gst_video_format_get_palette (GstVideoFormat format,
                                  gsize *size);

Get the default palette of `format` . This the palette used in the pack function for paletted formats.

#### Parameters

format | a GstVideoFormat |
size | size of the palette in bytes. | [out]

#### Returns

the default palette of `format` or `NULL` when `format` does not have a palette.

[transfer none]

Since: 1.2

### gst_video_format_get_info ()

    const GstVideoFormatInfo *
    gst_video_format_get_info (GstVideoFormat format);

Get the GstVideoFormatInfo for `format`

#### Parameters

format | a GstVideoFormat |

#### Returns

The GstVideoFormatInfo for `format` .

### GST_VIDEO_CAPS_MAKE()

    #define             GST_VIDEO_CAPS_MAKE(format)

Generic caps string for video, for use in pad templates.

#### Parameters

format | string format that describes the pixel layout, as string (e.g. "I420", "RGB", "YV12", "YUY2", "AYUV", etc.) |

### GST_VIDEO_CAPS_MAKE_WITH_FEATURES()

    #define             GST_VIDEO_CAPS_MAKE_WITH_FEATURES(features,format)

Generic caps string for video, for use in pad templates.

#### Parameters

format | string format that describes the pixel layout, as string (e.g. "I420", "RGB", "YV12", "YUY2", "AYUV", etc.) |
features | Requires caps features as a string, e.g. "memory:SystemMemory". |

Since: 1.2

### gst_video_color_range_offsets ()

    void
    gst_video_color_range_offsets (GstVideoColorRange range,
                                   const GstVideoFormatInfo *info,
                                   gint offset[GST_VIDEO_MAX_COMPONENTS],
                                   gint scale[GST_VIDEO_MAX_COMPONENTS]);

Compute the offset and scale values for each component of `info` . For each component, (c[i] - offset[i]) / scale[i] will scale the component c[i] to the range [0.0 .. 1.0].

The reverse operation (c[i] * scale[i]) + offset[i] can be used to convert the component values in range [0.0 .. 1.0] back to their representation in `info` and `range` .

#### Parameters

range | a GstVideoColorRange |
info | a GstVideoFormatInfo |
offset | output offsets. | [out caller-allocates][array fixed-size=4]
scale | output scale. | [out caller-allocates][array fixed-size=4]

### gst_video_color_matrix_get_Kr_Kb ()

    gboolean
    gst_video_color_matrix_get_Kr_Kb (GstVideoColorMatrix matrix,
                                      gdouble *Kr,
                                      gdouble *Kb);

Get the coefficients used to convert between Y'PbPr and R'G'B' using `matrix` .

When:

    1
    2
    0.0 <= [Y',R',G',B'] <= 1.0)
    (-0.5 <= [Pb,Pr] <= 0.5)

the general conversion is given by:

    1
    2
    3
    Y' = Kr*R' + (1-Kr-Kb)*G' + Kb*B'
    Pb = (B'-Y')/(2*(1-Kb))
    Pr = (R'-Y')/(2*(1-Kr))

and the other way around:

    1
    2
    3
    R' = Y' + Cr*2*(1-Kr)
    G' = Y' - Cb*2*(1-Kb)*Kb/(1-Kr-Kb) - Cr*2*(1-Kr)*Kr/(1-Kr-Kb)
    B' = Y' + Cb*2*(1-Kb)

#### Parameters

matrix | a GstVideoColorMatrix |
Kr | result red channel coefficient. | [out]
Kb | result blue channel coefficient. | [out]

#### Returns

TRUE if `matrix` was a YUV color format and `Kr` and `Kb` contain valid values.

Since: 1.6

### gst_video_color_transfer_decode ()

    gdouble
    gst_video_color_transfer_decode (GstVideoTransferFunction func,
                                     gdouble val);

Convert `val` to its gamma decoded value. This is the inverse operation of ``gst_video_color_transfer_encode()`` .

For a non-linear value L' in the range [0..1], conversion to the linear L is in general performed with a power function like:

    1
    L = L' ^ gamma

Depending on `func` , different formulas might be applied. Some formulas encode a linear segment in the lower range.

#### Parameters

func | a GstVideoTransferFunction |
val | a value |

#### Returns

the gamme decoded value of `val`

Since: 1.6

### gst_video_color_transfer_encode ()

    gdouble
    gst_video_color_transfer_encode (GstVideoTransferFunction func,
                                     gdouble val);

Convert `val` to its gamma encoded value.

For a linear value L in the range [0..1], conversion to the non-linear (gamma encoded) L' is in general performed with a power function like:

    1
    L' = L ^ (1 / gamma)

Depending on `func` , different formulas might be applied. Some formulas encode a linear segment in the lower range.

#### Parameters

func | a GstVideoTransferFunction |
val | a value |

#### Returns

the gamme encoded value of `val`

Since: 1.6

### gst_video_colorimetry_matches ()

    gboolean
    gst_video_colorimetry_matches (const GstVideoColorimetry *cinfo,
                                   const gchar *color);

Check if the colorimetry information in `info` matches that of the string `color` .

#### Parameters

cinfo | a GstVideoInfo |
color | a colorimetry string |

#### Returns

`TRUE` if `color` conveys the same colorimetry info as the color information in `info` .

### gst_video_colorimetry_is_equal ()

    gboolean
    gst_video_colorimetry_is_equal (const GstVideoColorimetry *cinfo,
                                    const GstVideoColorimetry *other);

Compare the 2 colorimetry sets for equality

#### Parameters

cinfo | a GstVideoColorimetry |
other | another GstVideoColorimetry |

#### Returns

`TRUE` if `cinfo` and `other` are equal.

Since: 1.6

### gst_video_colorimetry_from_string ()

    gboolean
    gst_video_colorimetry_from_string (GstVideoColorimetry *cinfo,
                                       const gchar *color);

Parse the colorimetry string and update `cinfo` with the parsed values.

#### Parameters

cinfo | a GstVideoColorimetry |
color | a colorimetry string |

#### Returns

`TRUE` if `color` points to valid colorimetry info.

### gst_video_colorimetry_to_string ()

    gchar *
    gst_video_colorimetry_to_string (const GstVideoColorimetry *cinfo);

Make a string representation of `cinfo` .

#### Parameters

cinfo | a GstVideoColorimetry |

#### Returns

a string representation of `cinfo` .

### GST_VIDEO_INFO_FORMAT()

    #define GST_VIDEO_INFO_FORMAT(i)         (GST_VIDEO_FORMAT_INFO_FORMAT((i)->finfo))

### GST_VIDEO_INFO_NAME()

    #define GST_VIDEO_INFO_NAME(i)           (GST_VIDEO_FORMAT_INFO_NAME((i)->finfo))

### GST_VIDEO_INFO_IS_YUV()

    #define GST_VIDEO_INFO_IS_YUV(i)         (GST_VIDEO_FORMAT_INFO_IS_YUV((i)->finfo))

### GST_VIDEO_INFO_IS_RGB()

    #define GST_VIDEO_INFO_IS_RGB(i)         (GST_VIDEO_FORMAT_INFO_IS_RGB((i)->finfo))

### GST_VIDEO_INFO_IS_GRAY()

    #define GST_VIDEO_INFO_IS_GRAY(i)        (GST_VIDEO_FORMAT_INFO_IS_GRAY((i)->finfo))

### GST_VIDEO_INFO_HAS_ALPHA()

    #define GST_VIDEO_INFO_HAS_ALPHA(i)      (GST_VIDEO_FORMAT_INFO_HAS_ALPHA((i)->finfo))

### GST_VIDEO_INFO_INTERLACE_MODE()

    #define GST_VIDEO_INFO_INTERLACE_MODE(i) ((i)->interlace_mode)

### GST_VIDEO_INFO_IS_INTERLACED()

    #define GST_VIDEO_INFO_IS_INTERLACED(i)  ((i)->interlace_mode != GST_VIDEO_INTERLACE_MODE_PROGRESSIVE)

### GST_VIDEO_INFO_FIELD_ORDER()

    #define GST_VIDEO_INFO_FIELD_ORDER(i)    ((i)->ABI.abi.field_order)

### GST_VIDEO_INFO_FLAGS()

    #define GST_VIDEO_INFO_FLAGS(i)          ((i)->flags)

### GST_VIDEO_INFO_WIDTH()

    #define GST_VIDEO_INFO_WIDTH(i)          ((i)->width)

### GST_VIDEO_INFO_HEIGHT()

    #define GST_VIDEO_INFO_HEIGHT(i)         ((i)->height)

### GST_VIDEO_INFO_SIZE()

    #define GST_VIDEO_INFO_SIZE(i)           ((i)->size)

### GST_VIDEO_INFO_VIEWS()

    #define GST_VIDEO_INFO_VIEWS(i)          ((i)->views)

### GST_VIDEO_INFO_PAR_N()

    #define GST_VIDEO_INFO_PAR_N(i)          ((i)->par_n)

### GST_VIDEO_INFO_PAR_D()

    #define GST_VIDEO_INFO_PAR_D(i)          ((i)->par_d)

### GST_VIDEO_INFO_FPS_N()

    #define GST_VIDEO_INFO_FPS_N(i)          ((i)->fps_n)

### GST_VIDEO_INFO_FPS_D()

    #define GST_VIDEO_INFO_FPS_D(i)          ((i)->fps_d)

### GST_VIDEO_INFO_FLAG_IS_SET()

    #define GST_VIDEO_INFO_FLAG_IS_SET(i,flag) ((GST_VIDEO_INFO_FLAGS(i) & (flag)) == (flag))

### GST_VIDEO_INFO_FLAG_SET()

    #define GST_VIDEO_INFO_FLAG_SET(i,flag)    (GST_VIDEO_INFO_FLAGS(i) |= (flag))

### GST_VIDEO_INFO_FLAG_UNSET()

    #define GST_VIDEO_INFO_FLAG_UNSET(i,flag)  (GST_VIDEO_INFO_FLAGS(i) &= ~(flag))

### GST_VIDEO_INFO_N_PLANES()

    #define GST_VIDEO_INFO_N_PLANES(i)       (GST_VIDEO_FORMAT_INFO_N_PLANES((i)->finfo))

### GST_VIDEO_INFO_PLANE_OFFSET()

    #define GST_VIDEO_INFO_PLANE_OFFSET(i,p) ((i)->offset[p])

### GST_VIDEO_INFO_PLANE_STRIDE()

    #define GST_VIDEO_INFO_PLANE_STRIDE(i,p) ((i)->stride[p])

### GST_VIDEO_INFO_N_COMPONENTS()

    #define GST_VIDEO_INFO_N_COMPONENTS(i)   GST_VIDEO_FORMAT_INFO_N_COMPONENTS((i)->finfo)

### GST_VIDEO_INFO_COMP_DEPTH()

    #define GST_VIDEO_INFO_COMP_DEPTH(i,c)   GST_VIDEO_FORMAT_INFO_DEPTH((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_DATA()

    #define GST_VIDEO_INFO_COMP_DATA(i,d,c)  GST_VIDEO_FORMAT_INFO_DATA((i)->finfo,d,(c))

### GST_VIDEO_INFO_COMP_OFFSET()

    #define GST_VIDEO_INFO_COMP_OFFSET(i,c)  GST_VIDEO_FORMAT_INFO_OFFSET((i)->finfo,(i)->offset,(c))

### GST_VIDEO_INFO_COMP_STRIDE()

    #define GST_VIDEO_INFO_COMP_STRIDE(i,c)  GST_VIDEO_FORMAT_INFO_STRIDE((i)->finfo,(i)->stride,(c))

### GST_VIDEO_INFO_COMP_WIDTH()

    #define GST_VIDEO_INFO_COMP_WIDTH(i,c)   GST_VIDEO_FORMAT_INFO_SCALE_WIDTH((i)->finfo,(c),(i)->width)

### GST_VIDEO_INFO_COMP_HEIGHT()

    #define GST_VIDEO_INFO_COMP_HEIGHT(i,c)  GST_VIDEO_FORMAT_INFO_SCALE_HEIGHT((i)->finfo,(c),(i)->height)

### GST_VIDEO_INFO_COMP_PLANE()

    #define GST_VIDEO_INFO_COMP_PLANE(i,c)   GST_VIDEO_FORMAT_INFO_PLANE((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_PSTRIDE()

    #define GST_VIDEO_INFO_COMP_PSTRIDE(i,c) GST_VIDEO_FORMAT_INFO_PSTRIDE((i)->finfo,(c))

### GST_VIDEO_INFO_COMP_POFFSET()

    #define GST_VIDEO_INFO_COMP_POFFSET(i,c) GST_VIDEO_FORMAT_INFO_POFFSET((i)->finfo,(c))

### GST_VIDEO_INFO_CHROMA_SITE()

    #define GST_VIDEO_INFO_CHROMA_SITE(i) ((i)->chroma_site)

### GST_VIDEO_INFO_COLORIMETRY()

    #define GST_VIDEO_INFO_COLORIMETRY(i) ((i)->colorimetry)

### GST_VIDEO_INFO_MULTIVIEW_FLAGS()

    #define GST_VIDEO_INFO_MULTIVIEW_FLAGS(i)          ((i)->ABI.abi.multiview_flags)

### GST_VIDEO_INFO_MULTIVIEW_MODE()

    #define GST_VIDEO_INFO_MULTIVIEW_MODE(i)          ((i)->ABI.abi.multiview_mode)

### gst_video_info_init ()

    void
    gst_video_info_init (GstVideoInfo *info);

Initialize `info` with default values.

#### Parameters

info | a GstVideoInfo |

### gst_video_info_new ()

    GstVideoInfo *
    gst_video_info_new (void);

Allocate a new GstVideoInfo that is also initialized with `gst_video_info_init()`.

#### Returns

a new GstVideoInfo. free with `gst_video_info_free()`.

Since: 1.6

### gst_video_info_copy ()

    GstVideoInfo *
    gst_video_info_copy (const GstVideoInfo *info);

Copy a GstVideoInfo structure.

#### Parameters

info | a GstVideoInfo |

#### Returns

a new GstVideoInfo. free with gst_video_info_free.

Since: 1.6

### gst_video_info_free ()

    void
    gst_video_info_free (GstVideoInfo *info);

Free a GstVideoInfo structure previously allocated with `gst_video_info_new()` or `gst_video_info_copy()`.

#### Parameters

info | a GstVideoInfo |

Since: 1.6

### gst_video_info_set_format ()

    gboolean
    gst_video_info_set_format (GstVideoInfo *info,
                               GstVideoFormat format,
                               guint width,
                               guint height);

Set the default info for a video frame of `format` and `width` and `height` .

Note: This initializes `info` first, no values are preserved. This function does not set the offsets correctly for interlaced vertically subsampled formats.

#### Parameters

info | a GstVideoInfo |
format | the format |
width | a width |
height | a height |

#### Returns

`FALSE` if the returned video info is invalid, e.g. because the size of a frame can't be represented as a 32 bit integer (Since: 1.12)

### gst_video_info_from_caps ()

    gboolean
    gst_video_info_from_caps (GstVideoInfo *info,
                              const GstCaps *caps);

Parse `caps` and update `info` .

#### Parameters

info | a GstVideoInfo |
caps | a GstCaps |

#### Returns

TRUE if `caps` could be parsed

### gst_video_info_to_caps ()

    GstCaps *
    gst_video_info_to_caps (GstVideoInfo *info);

Convert the values of `info` into a GstCaps.

#### Parameters

info | a GstVideoInfo |

#### Returns

a new GstCaps containing the info of `info` .

### gst_video_info_convert ()

    gboolean
    gst_video_info_convert (GstVideoInfo *info,
                            GstFormat src_format,
                            gint64 src_value,
                            GstFormat dest_format,
                            gint64 *dest_value);

Converts among various GstFormat types. This function handles GST_FORMAT_BYTES, GST_FORMAT_TIME, and GST_FORMAT_DEFAULT. For raw video, GST_FORMAT_DEFAULT corresponds to video frames. This function can be used to handle pad queries of the type GST_QUERY_CONVERT.

#### Parameters

info | a GstVideoInfo |
src_format | GstFormat of the `src_value` |
src_value | value to convert |
dest_format | GstFormat of the `dest_value` |
dest_value | pointer to destination value. | [out]

#### Returns

TRUE if the conversion was successful.

### gst_video_info_is_equal ()

    gboolean
    gst_video_info_is_equal (const GstVideoInfo *info,
                             const GstVideoInfo *other);

Compares two GstVideoInfo and returns whether they are equal or not

#### Parameters

info | a GstVideoInfo |
other | a GstVideoInfo |

#### Returns

`TRUE` if `info` and `other` are equal, else `FALSE`.

### gst_video_info_align ()

    gboolean
    gst_video_info_align (GstVideoInfo *info,
                          GstVideoAlignment *align);

Adjust the offset and stride fields in `info` so that the padding and stride alignment in `align` is respected.

Extra padding will be added to the right side when stride alignment padding is required and `align` will be updated with the new padding values.

#### Parameters

info | a GstVideoInfo |
align | alignment parameters |

#### Returns

`FALSE` if alignment could not be applied, e.g. because the size of a frame can't be represented as a 32 bit integer (Since: 1.12)

### gst_video_interlace_mode_from_string ()

    GstVideoInterlaceMode
    gst_video_interlace_mode_from_string (const gchar *mode);

Convert `mode` to a GstVideoInterlaceMode

#### Parameters

mode | a mode |

#### Returns

the GstVideoInterlaceMode of `mode` or GST_VIDEO_INTERLACE_MODE_PROGRESSIVE when `mode` is not a valid string representation for a GstVideoInterlaceMode.

Since: 1.6

### gst_video_interlace_mode_to_string ()

    const gchar *
    gst_video_interlace_mode_to_string (GstVideoInterlaceMode mode);

Convert `mode` to its string representation.

#### Parameters

mode | a GstVideoInterlaceMode |

#### Returns

`mode` as a string or NULL if `mode` in invalid.

Since: 1.6

### gst_video_field_order_from_string ()

    GstVideoFieldOrder
    gst_video_field_order_from_string (const gchar *order);

Convert `order` to a GstVideoFieldOrder

#### Parameters

order | a field order |

#### Returns

the GstVideoFieldOrder of `order` or GST_VIDEO_FIELD_ORDER_UNKNOWN when `order` is not a valid string representation for a GstVideoFieldOrder.

Since: 1.12

### gst_video_field_order_to_string ()

    const gchar *
    gst_video_field_order_to_string (GstVideoFieldOrder order);

Convert `order` to its string representation.

#### Parameters

order | a GstVideoFieldOrder |

#### Returns

`order` as a string or NULL if `order` in invalid.

Since: 1.12

### gst_video_frame_map_id ()

    gboolean
    gst_video_frame_map_id (GstVideoFrame *frame,
                            GstVideoInfo *info,
                            GstBuffer *buffer,
                            gint id,
                            GstMapFlags flags);

Use `info` and `buffer` to fill in the values of `frame` with the video frame information of frame `id` .

When `id` is -1, the default frame is mapped. When `id` != -1, this function will return `FALSE` when there is no GstVideoMeta with that id.

All video planes of `buffer` will be mapped and the pointers will be set in `frame->data` .

#### Parameters

frame | pointer to GstVideoFrame |
info | a GstVideoInfo |
buffer | the buffer to map |
id | the frame id to map |
flags | GstMapFlags |

#### Returns

`TRUE` on success.

### gst_video_frame_map ()

    gboolean
    gst_video_frame_map (GstVideoFrame *frame,
                         GstVideoInfo *info,
                         GstBuffer *buffer,
                         GstMapFlags flags);

Use `info` and `buffer` to fill in the values of `frame` . `frame` is usually allocated on the stack, and you will pass the address to the GstVideoFrame structure allocated on the stack; `gst_video_frame_map()` will then fill in the structures with the various video-specific information you need to access the pixels of the video buffer. You can then use accessor macros such as `GST_VIDEO_FRAME_COMP_DATA()`, `GST_VIDEO_FRAME_PLANE_DATA()`, `GST_VIDEO_FRAME_COMP_STRIDE()`, `GST_VIDEO_FRAME_PLANE_STRIDE()` etc. to get to the pixels.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    GstVideoFrame vframe;
    ...
    // set RGB pixels to black one at a time
    if (gst_video_frame_map (&vframe, video_info, video_buffer, GST_MAP_WRITE)) {
      guint8 *pixels = GST_VIDEO_FRAME_PLANE_DATA (vframe, 0);
      guint stride = GST_VIDEO_FRAME_PLANE_STRIDE (vframe, 0);
      guint pixel_stride = GST_VIDEO_FRAME_COMP_PSTRIDE (vframe, 0);

      for (h = 0; h < height; ++h) {
        for (w = 0; w < width; ++w) {
          guint8 *pixel = pixels + h * stride + w * pixel_stride;

          memset (pixel, 0, pixel_stride);
        }
      }

      gst_video_frame_unmap (&vframe);
    }
    ...

All video planes of `buffer` will be mapped and the pointers will be set in `frame->data` .

The purpose of this function is to make it easy for you to get to the video pixels in a generic way, without you having to worry too much about details such as whether the video data is allocated in one contiguous memory chunk or multiple memory chunks (e.g. one for each plane); or if custom strides and custom plane offsets are used or not (as signalled by GstVideoMeta on each buffer). This function will just fill the GstVideoFrame structure with the right values and if you use the accessor macros everything will just work and you can access the data easily. It also maps the underlying memory chunks for you.

#### Parameters

frame | pointer to GstVideoFrame |
info | a GstVideoInfo |
buffer | the buffer to map |
flags | GstMapFlags |

#### Returns

`TRUE` on success.

### gst_video_frame_unmap ()

    void
    gst_video_frame_unmap (GstVideoFrame *frame);

Unmap the memory previously mapped with gst_video_frame_map.

#### Parameters

frame | a GstVideoFrame |

### gst_video_frame_copy ()

    gboolean
    gst_video_frame_copy (GstVideoFrame *dest,
                          const GstVideoFrame *src);

Copy the contents from `src` to `dest` .

#### Parameters

dest | a GstVideoFrame |
src | a GstVideoFrame |

#### Returns

TRUE if the contents could be copied.

### gst_video_frame_copy_plane ()

    gboolean
    gst_video_frame_copy_plane (GstVideoFrame *dest,
                                const GstVideoFrame *src,
                                guint plane);

Copy the plane with index `plane` from `src` to `dest` .

#### Parameters

dest | a GstVideoFrame |
src | a GstVideoFrame |
plane | a plane |

#### Returns

TRUE if the contents could be copied.

### GST_VIDEO_FRAME_FORMAT()

    #define GST_VIDEO_FRAME_FORMAT(f)         (GST_VIDEO_INFO_FORMAT(&(f)->info))

### GST_VIDEO_FRAME_WIDTH()

    #define GST_VIDEO_FRAME_WIDTH(f)          (GST_VIDEO_INFO_WIDTH(&(f)->info))

### GST_VIDEO_FRAME_HEIGHT()

    #define GST_VIDEO_FRAME_HEIGHT(f)         (GST_VIDEO_INFO_HEIGHT(&(f)->info))

### GST_VIDEO_FRAME_SIZE()

    #define GST_VIDEO_FRAME_SIZE(f)           (GST_VIDEO_INFO_SIZE(&(f)->info))

### GST_VIDEO_FRAME_FLAGS()

    #define GST_VIDEO_FRAME_FLAGS(f)          ((f)->flags)

### GST_VIDEO_FRAME_FLAG_IS_SET()

    #define GST_VIDEO_FRAME_FLAG_IS_SET(f,fl) ((GST_VIDEO_FRAME_FLAGS(f) & (fl)) == (fl))

### GST_VIDEO_FRAME_IS_INTERLACED()

    #define GST_VIDEO_FRAME_IS_INTERLACED(f)  (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_INTERLACED))

### GST_VIDEO_FRAME_IS_TFF()

    #define GST_VIDEO_FRAME_IS_TFF(f)         (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_TFF))

### GST_VIDEO_FRAME_IS_RFF()

    #define GST_VIDEO_FRAME_IS_RFF(f)         (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_RFF))

### GST_VIDEO_FRAME_IS_ONEFIELD()

    #define GST_VIDEO_FRAME_IS_ONEFIELD(f)    (GST_VIDEO_FRAME_FLAG_IS_SET(f, GST_VIDEO_FRAME_FLAG_ONEFIELD))

### GST_VIDEO_FRAME_N_PLANES()

    #define GST_VIDEO_FRAME_N_PLANES(f)       (GST_VIDEO_INFO_N_PLANES(&(f)->info))

### GST_VIDEO_FRAME_PLANE_DATA()

    #define GST_VIDEO_FRAME_PLANE_DATA(f,p)   ((f)->data[p])

### GST_VIDEO_FRAME_PLANE_OFFSET()

    #define GST_VIDEO_FRAME_PLANE_OFFSET(f,p) (GST_VIDEO_INFO_PLANE_OFFSET(&(f)->info,(p)))

### GST_VIDEO_FRAME_PLANE_STRIDE()

    #define GST_VIDEO_FRAME_PLANE_STRIDE(f,p) (GST_VIDEO_INFO_PLANE_STRIDE(&(f)->info,(p)))

### GST_VIDEO_FRAME_N_COMPONENTS()

    #define GST_VIDEO_FRAME_N_COMPONENTS(f)   GST_VIDEO_INFO_N_COMPONENTS(&(f)->info)

### GST_VIDEO_FRAME_COMP_DEPTH()

    #define GST_VIDEO_FRAME_COMP_DEPTH(f,c)   GST_VIDEO_INFO_COMP_DEPTH(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_DATA()

    #define GST_VIDEO_FRAME_COMP_DATA(f,c)    GST_VIDEO_INFO_COMP_DATA(&(f)->info,(f)->data,(c))

### GST_VIDEO_FRAME_COMP_STRIDE()

    #define GST_VIDEO_FRAME_COMP_STRIDE(f,c)  GST_VIDEO_INFO_COMP_STRIDE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_OFFSET()

    #define GST_VIDEO_FRAME_COMP_OFFSET(f,c)  GST_VIDEO_INFO_COMP_OFFSET(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_WIDTH()

    #define GST_VIDEO_FRAME_COMP_WIDTH(f,c)   GST_VIDEO_INFO_COMP_WIDTH(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_HEIGHT()

    #define GST_VIDEO_FRAME_COMP_HEIGHT(f,c)  GST_VIDEO_INFO_COMP_HEIGHT(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_PLANE()

    #define GST_VIDEO_FRAME_COMP_PLANE(f,c)   GST_VIDEO_INFO_COMP_PLANE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_PSTRIDE()

    #define GST_VIDEO_FRAME_COMP_PSTRIDE(f,c) GST_VIDEO_INFO_COMP_PSTRIDE(&(f)->info,(c))

### GST_VIDEO_FRAME_COMP_POFFSET()

    #define GST_VIDEO_FRAME_COMP_POFFSET(f,c) GST_VIDEO_INFO_COMP_POFFSET(&(f)->info,(c))

### gst_video_tile_get_index ()

    guint
    gst_video_tile_get_index (GstVideoTileMode mode,
                              gint x,
                              gint y,
                              gint x_tiles,
                              gint y_tiles);

Get the tile index of the tile at coordinates `x` and `y` in the tiled image of `x_tiles` by `y_tiles` .

Use this method when `mode` is of type `GST_VIDEO_TILE_MODE_INDEXED`.

#### Parameters

mode | a GstVideoTileMode |
x | x coordinate |
y | y coordinate |
x_tiles | number of horizintal tiles |
y_tiles | number of vertical tiles |

#### Returns

the index of the tile at `x` and `y` in the tiled image of `x_tiles` by `y_tiles` .

Since: 1.4

### GST_VIDEO_TILE_MAKE_MODE()

    #define             GST_VIDEO_TILE_MAKE_MODE(num, type)

use this macro to create new tile modes.

#### Parameters

num | the mode number to create |
type | the tile mode type |

### GST_VIDEO_TILE_MODE_TYPE()

    #define GST_VIDEO_TILE_MODE_TYPE(mode)       ((mode) & GST_VIDEO_TILE_TYPE_MASK)

Get the tile mode type of `mode`

#### Parameters

mode | the tile mode |

### GST_VIDEO_TILE_MODE_IS_INDEXED()

    #define GST_VIDEO_TILE_MODE_IS_INDEXED(mode) (GST_VIDEO_TILE_MODE_TYPE(mode) == GST_VIDEO_TILE_TYPE_INDEXED)

Check if `mode` is an indexed tile type

#### Parameters

mode | a tile mode |

### GST_VIDEO_TILE_MAKE_STRIDE()

    #define             GST_VIDEO_TILE_MAKE_STRIDE(x_tiles, y_tiles)

Encode the number of tile in X and Y into the stride.

#### Parameters

x_tiles | number of tiles in X |
y_tiles | number of tiles in Y |

### GST_VIDEO_TILE_X_TILES()

    #define GST_VIDEO_TILE_X_TILES(stride) ((stride) & GST_VIDEO_TILE_X_TILES_MASK)

Extract the number of tiles in X from the stride value.

#### Parameters

stride | plane stride |

### GST_VIDEO_TILE_Y_TILES()

    #define GST_VIDEO_TILE_Y_TILES(stride) ((stride) >> GST_VIDEO_TILE_Y_TILES_SHIFT)

Extract the number of tiles in Y from the stride value.

#### Parameters

stride | plane stride |

### gst_video_blend ()

    gboolean
    gst_video_blend (GstVideoFrame *dest,
                     GstVideoFrame *src,
                     gint x,
                     gint y,
                     gfloat global_alpha);

Lets you blend the `src` image into the `dest` image

#### Parameters

dest | The GstVideoFrame where to blend `src` in |
src | the GstVideoFrame that we want to blend into |
x | The x offset in pixel where the `src` image should be blended |
y | the y offset in pixel where the `src` image should be blended |
global_alpha | the global_alpha each per-pixel alpha value is multiplied with |

### gst_video_blend_scale_linear_RGBA ()

    void
    gst_video_blend_scale_linear_RGBA (GstVideoInfo *src,
                                       GstBuffer *src_buffer,
                                       gint dest_height,
                                       gint dest_width,
                                       GstVideoInfo *dest,
                                       GstBuffer **dest_buffer);

Scales a buffer containing RGBA (or AYUV) video. This is an internal helper function which is used to scale subtitle overlays, and may be deprecated in the near future. Use GstVideoScaler to scale video buffers instead.

#### Parameters

src | the GstVideoInfo describing the video data in `src_buffer` |
src_buffer | the source buffer containing video pixels to scale |
dest_height | the height in pixels to scale the video data in `src_buffer` to |
dest_width | the width in pixels to scale the video data in `src_buffer` to |
dest | pointer to a GstVideoInfo structure that will be filled in with the details for `dest_buffer` . | [out]
dest_buffer | a pointer to a GstBuffer variable, which will be set to a newly-allocated buffer containing the scaled pixels. | [out]

### gst_video_converter_new ()

    GstVideoConverter *
    gst_video_converter_new (GstVideoInfo *in_info,
                             GstVideoInfo *out_info,
                             GstStructure *config);

Create a new converter object to convert between `in_info` and `out_info` with `config` .

[skip]

#### Parameters

in_info | a GstVideoInfo |
out_info | a GstVideoInfo |
config | a GstStructure with configuration options. | [transfer full]

#### Returns

a GstVideoConverter or `NULL` if conversion is not possible.

Since: 1.6

### gst_video_converter_free ()

    void
    gst_video_converter_free (GstVideoConverter *convert);

Free `convert`

#### Parameters

convert | a GstVideoConverter |

Since: 1.6

### gst_video_converter_get_config ()

    const GstStructure *
    gst_video_converter_get_config (GstVideoConverter *convert);

Get the current configuration of `convert` .

#### Parameters

convert | a GstVideoConverter |

#### Returns

a GstStructure that remains valid for as long as `convert` is valid or until `gst_video_converter_set_config()` is called.

### gst_video_converter_set_config ()

    gboolean
    gst_video_converter_set_config (GstVideoConverter *convert,
                                    GstStructure *config);

Set `config` as extra configuraion for `convert` .

If the parameters in `config` can not be set exactly, this function returns `FALSE` and will try to update as much state as possible. The new state can then be retrieved and refined with `gst_video_converter_get_config()`.

Look at the GST_VIDEO_CONVERTER_OPT_* fields to check valid configuration option and values.

#### Parameters

convert | a GstVideoConverter |
config | a GstStructure. | [transfer full]

#### Returns

`TRUE` when `config` could be set.

Since: 1.6

### gst_video_converter_frame ()

    void
    gst_video_converter_frame (GstVideoConverter *convert,
                               const GstVideoFrame *src,
                               GstVideoFrame *dest);

Convert the pixels of `src` into `dest` using `convert` .

#### Parameters

convert | a GstVideoConverter |
dest | a GstVideoFrame |
src | a GstVideoFrame |

Since: 1.6

### gst_video_multiview_get_mono_modes ()

    const GValue *
    gst_video_multiview_get_mono_modes (void);

#### Returns

A const GValue containing a list of mono video modes

Utility function that returns a GValue with a GstList of mono video modes (mono/left/right) for use in caps negotiations.

Since: 1.6

### gst_video_multiview_get_unpacked_modes ()

    const GValue *
    gst_video_multiview_get_unpacked_modes
                                   (void);

#### Returns

A const GValue containing a list of 'unpacked' stereo video modes

Utility function that returns a GValue with a GstList of unpacked stereo video modes (separated/frame-by-frame/frame-by-frame-multiview) for use in caps negotiations.

Since: 1.6

### gst_video_multiview_get_doubled_height_modes ()

    const GValue *
    gst_video_multiview_get_doubled_height_modes
                                   (void);

#### Returns

A const GValue containing a list of stereo video modes

Utility function that returns a GValue with a GstList of packed stereo video modes with double the height of a single view for use in caps negotiations. Currently this is top-bottom and row-interleaved.

Since: 1.6

### gst_video_multiview_get_doubled_size_modes ()

    const GValue *
    gst_video_multiview_get_doubled_size_modes
                                   (void);

#### Returns

A const GValue containing a list of stereo video modes

Utility function that returns a GValue with a GstList of packed stereo video modes that have double the width/height of a single view for use in caps negotiation. Currently this is just 'checkerboard' layout.

Since: 1.6

### gst_video_multiview_get_doubled_width_modes ()

    const GValue *
    gst_video_multiview_get_doubled_width_modes
                                   (void);

#### Returns

A const GValue containing a list of stereo video modes

Utility function that returns a GValue with a GstList of packed stereo video modes with double the width of a single view for use in caps negotiations. Currently this is side-by-side, side-by-side-quincunx and column-interleaved.

Since: 1.6

### gst_video_multiview_mode_from_caps_string ()

    GstVideoMultiviewMode
    gst_video_multiview_mode_from_caps_string
                                   (const gchar *caps_mview_mode);

#### Parameters

caps_mview_mode | multiview-mode field string from caps |

#### Returns

The GstVideoMultiviewMode value

Given a string from a caps multiview-mode field, output the corresponding GstVideoMultiviewMode or GST_VIDEO_MULTIVIEW_MODE_NONE

Since: 1.6

### gst_video_multiview_mode_to_caps_string ()

    const gchar *
    gst_video_multiview_mode_to_caps_string
                                   (GstVideoMultiviewMode mview_mode);

#### Parameters

mview_mode | A GstVideoMultiviewMode value |

#### Returns

The caps string representation of the mode, or NULL if invalid.

Given a GstVideoMultiviewMode returns the multiview-mode caps string for insertion into a caps structure

Since: 1.6

### gst_video_multiview_guess_half_aspect ()

    gboolean
    gst_video_multiview_guess_half_aspect (GstVideoMultiviewMode mv_mode,
                                           guint width,
                                           guint height,
                                           guint par_n,
                                           guint par_d);

#### Parameters

mv_mode | A GstVideoMultiviewMode |
width | Video frame width in pixels |
height | Video frame height in pixels |
par_n | Numerator of the video pixel-aspect-ratio |
par_d | Denominator of the video pixel-aspect-ratio |

#### Returns

A boolean indicating whether the GST_VIDEO_MULTIVIEW_FLAG_HALF_ASPECT flag should be set.

Utility function that heuristically guess whether a frame-packed stereoscopic video contains half width/height encoded views, or full-frame views by looking at the overall display aspect ratio.

Since: 1.6

### gst_video_multiview_video_info_change_mode ()

    void
    gst_video_multiview_video_info_change_mode
                                   (GstVideoInfo *info,
                                    GstVideoMultiviewMode out_mview_mode,
                                    GstVideoMultiviewFlags out_mview_flags);

Utility function that transforms the width/height/PAR and multiview mode and flags of a GstVideoInfo into the requested mode.

#### Parameters

info | A GstVideoInfo structure to operate on |
out_mview_mode | A GstVideoMultiviewMode value |
out_mview_flags | A set of GstVideoMultiviewFlags |

Since: 1.6

### gst_video_time_code_new ()

    GstVideoTimeCode *
    gst_video_time_code_new (guint fps_n,
                             guint fps_d,
                             GDateTime *latest_daily_jam,
                             GstVideoTimeCodeFlags flags,
                             guint hours,
                             guint minutes,
                             guint seconds,
                             guint frames,
                             guint field_count);

`field_count` is 0 for progressive, 1 or 2 for interlaced. `latest_daiy_jam` reference is stolen from caller.

#### Parameters

fps_n | Numerator of the frame rate |
fps_d | Denominator of the frame rate |
latest_daily_jam | The latest daily jam of the GstVideoTimeCode |
flags | GstVideoTimeCodeFlags |
hours | the hours field of GstVideoTimeCode |
minutes | the minutes field of GstVideoTimeCode |
seconds | the seconds field of GstVideoTimeCode |
frames | the frames field of GstVideoTimeCode |
field_count | Interlaced video field count |

#### Returns

a new GstVideoTimeCode with the given values. The values are not checked for being in a valid range. To see if your timecode actually has valid content, use gst_video_time_code_is_valid.

Since: 1.10

### gst_video_time_code_new_empty ()

    GstVideoTimeCode *
    gst_video_time_code_new_empty (void);

#### Returns

a new empty GstVideoTimeCode

Since: 1.10

### gst_video_time_code_free ()

    void
    gst_video_time_code_free (GstVideoTimeCode *tc);

Frees `tc` .

#### Parameters

tc | a GstVideoTimeCode |

Since: 1.10

### gst_video_time_code_copy ()

    GstVideoTimeCode *
    gst_video_time_code_copy (const GstVideoTimeCode *tc);

#### Parameters

tc | a GstVideoTimeCode |

#### Returns

a new GstVideoTimeCode with the same values as `tc` .

Since: 1.10

### gst_video_time_code_init ()

    void
    gst_video_time_code_init (GstVideoTimeCode *tc,
                              guint fps_n,
                              guint fps_d,
                              GDateTime *latest_daily_jam,
                              GstVideoTimeCodeFlags flags,
                              guint hours,
                              guint minutes,
                              guint seconds,
                              guint frames,
                              guint field_count);

`field_count` is 0 for progressive, 1 or 2 for interlaced. `latest_daiy_jam` reference is stolen from caller.

Initializes `tc` with the given values. The values are not checked for being in a valid range. To see if your timecode actually has valid content, use gst_video_time_code_is_valid.

#### Parameters

tc | a GstVideoTimeCode |
fps_n | Numerator of the frame rate |
fps_d | Denominator of the frame rate |
latest_daily_jam | The latest daily jam of the GstVideoTimeCode |
flags | GstVideoTimeCodeFlags |
hours | the hours field of GstVideoTimeCode |
minutes | the minutes field of GstVideoTimeCode |
seconds | the seconds field of GstVideoTimeCode |
frames | the frames field of GstVideoTimeCode |
field_count | Interlaced video field count |

Since: 1.10

### gst_video_time_code_init_from_date_time ()

    void
    gst_video_time_code_init_from_date_time
                                   (GstVideoTimeCode *tc,
                                    guint fps_n,
                                    guint fps_d,
                                    GDateTime *dt,
                                    GstVideoTimeCodeFlags flags,
                                    guint field_count);

The resulting config->latest_daily_jam is set to midnight, and timecode is set to the given time.

#### Parameters

tc | a GstVideoTimeCode |
fps_n | Numerator of the frame rate |
fps_d | Denominator of the frame rate |
dt | GDateTime to convert |
flags | GstVideoTimeCodeFlags |
field_count | Interlaced video field count |

Since: 1.12

### gst_video_time_code_clear ()

    void
    gst_video_time_code_clear (GstVideoTimeCode *tc);

Initializes `tc` with empty/zero/NULL values.

#### Parameters

tc | a GstVideoTimeCode |

Since: 1.10

### gst_video_time_code_is_valid ()

    gboolean
    gst_video_time_code_is_valid (const GstVideoTimeCode *tc);

#### Parameters

tc | GstVideoTimeCode to check |

#### Returns

whether `tc` is a valid timecode (supported frame rate, hours/minutes/seconds/frames not overflowing)

Since: 1.10

### gst_video_time_code_compare ()

    gint
    gst_video_time_code_compare (const GstVideoTimeCode *tc1,
                                 const GstVideoTimeCode *tc2);

Compares `tc1` and `tc2` . If both have latest daily jam information, it is taken into account. Otherwise, it is assumed that the daily jam of both `tc1` and `tc2` was at the same time. Both time codes must be valid.

#### Parameters

tc1 | a GstVideoTimeCode |
tc2 | another GstVideoTimeCode |

#### Returns

1 if `tc1` is after `tc2` , -1 if `tc1` is before `tc2` , 0 otherwise.

Since: 1.10

### gst_video_time_code_increment_frame ()

    void
    gst_video_time_code_increment_frame (GstVideoTimeCode *tc);

Adds one frame to `tc` .

#### Parameters

tc | a valid GstVideoTimeCode |

Since: 1.10

### gst_video_time_code_add_frames ()

    void
    gst_video_time_code_add_frames (GstVideoTimeCode *tc,
                                    gint64 frames);

Adds or subtracts `frames` amount of frames to `tc` . tc needs to contain valid data, as verified by gst_video_time_code_is_valid.

#### Parameters

tc | a valid GstVideoTimeCode |
frames | How many frames to add or subtract |

Since: 1.10

### gst_video_time_code_frames_since_daily_jam ()

    guint64
    gst_video_time_code_frames_since_daily_jam
                                   (const GstVideoTimeCode *tc);

#### Parameters

tc | a valid GstVideoTimeCode |

#### Returns

how many frames have passed since the daily jam of `tc` .

Since: 1.10

### gst_video_time_code_nsec_since_daily_jam ()

    guint64
    gst_video_time_code_nsec_since_daily_jam
                                   (const GstVideoTimeCode *tc);

#### Parameters

tc | a valid GstVideoTimeCode |

#### Returns

how many nsec have passed since the daily jam of `tc` .

Since: 1.10

### gst_video_time_code_to_date_time ()

    GDateTime *
    gst_video_time_code_to_date_time (const GstVideoTimeCode *tc);

The `tc.config->latest_daily_jam` is required to be non-NULL.

#### Parameters

tc | A valid GstVideoTimeCode to convert |

#### Returns

the GDateTime representation of `tc` .

Since: 1.10

### gst_video_time_code_to_string ()

    gchar *
    gst_video_time_code_to_string (const GstVideoTimeCode *tc);

#### Parameters

tc | GstVideoTimeCode to convert |

#### Returns

the SMPTE ST 2059-1:2015 string representation of `tc` . That will take the form hh:mm:ss:ff . The last separator (between seconds and frames) may vary:

';' for drop-frame, non-interlaced content and for drop-frame interlaced field 2 ',' for drop-frame interlaced field 1 ':' for non-drop-frame, non-interlaced content and for non-drop-frame interlaced field 2 '.' for non-drop-frame interlaced field 1

Since: 1.10

### gst_video_time_code_add_interval ()

    GstVideoTimeCode *
    gst_video_time_code_add_interval (const GstVideoTimeCode *tc,
                                      const GstVideoTimeCodeInterval *tc_inter);

This makes a component-wise addition of `tc_inter` to `tc` . For example, adding ("01:02:03:04", "00:01:00:00") will return "01:03:03:04". When it comes to drop-frame timecodes, adding ("00:00:00;00", "00:01:00:00") will return "00:01:00;02" because of drop-frame oddities. However, adding ("00:09:00;02", "00:01:00:00") will return "00:10:00;00" because this time we can have an exact minute.

#### Parameters

tc | The GstVideoTimeCode where the diff should be added. This must contain valid timecode values. |
tc_inter | The GstVideoTimeCodeInterval to add to `tc` . The interval must contain valid values, except that for drop-frame timecode, it may also contain timecodes which would normally be dropped. These are then corrected to the next reasonable timecode. |

#### Returns

A new GstVideoTimeCode with `tc_inter` added.

Since: 1.12

### gst_video_time_code_new_from_string ()

    GstVideoTimeCode *
    gst_video_time_code_new_from_string (const gchar *tc_str);

#### Parameters

tc_str | The string that represents the GstVideoTimeCode |

#### Returns

a new GstVideoTimeCode from the given string

Since: 1.12

### gst_video_time_code_new_from_date_time ()

    GstVideoTimeCode *
    gst_video_time_code_new_from_date_time
                                   (guint fps_n,
                                    guint fps_d,
                                    GDateTime *dt,
                                    GstVideoTimeCodeFlags flags,
                                    guint field_count);

The resulting config->latest_daily_jam is set to midnight, and timecode is set to the given time.

#### Parameters

fps_n | Numerator of the frame rate |
fps_d | Denominator of the frame rate |
dt | GDateTime to convert |
flags | GstVideoTimeCodeFlags |
field_count | Interlaced video field count |

#### Returns

the GVideoTimeCode representation of `dt` .

Since: 1.12

### gst_video_time_code_interval_new ()

    GstVideoTimeCodeInterval *
    gst_video_time_code_interval_new (guint hours,
                                      guint minutes,
                                      guint seconds,
                                      guint frames);

#### Parameters

hours | the hours field of GstVideoTimeCodeInterval |
minutes | the minutes field of GstVideoTimeCodeInterval |
seconds | the seconds field of GstVideoTimeCodeInterval |
frames | the frames field of GstVideoTimeCodeInterval |

#### Returns

a new GstVideoTimeCodeInterval with the given values.

Since: 1.12

### gst_video_time_code_interval_new_from_string ()

    GstVideoTimeCodeInterval *
    gst_video_time_code_interval_new_from_string
                                   (const gchar *tc_inter_str);

`tc_inter_str` must only have ":" as separators.

#### Parameters

tc_inter_str | The string that represents the GstVideoTimeCodeInterval |

#### Returns

a new GstVideoTimeCodeInterval from the given string

Since: 1.12

### gst_video_time_code_interval_init ()

    void
    gst_video_time_code_interval_init (GstVideoTimeCodeInterval *tc,
                                       guint hours,
                                       guint minutes,
                                       guint seconds,
                                       guint frames);

Initializes `tc` with the given values.

#### Parameters

tc | a GstVideoTimeCodeInterval |
hours | the hours field of GstVideoTimeCodeInterval |
minutes | the minutes field of GstVideoTimeCodeInterval |
seconds | the seconds field of GstVideoTimeCodeInterval |
frames | the frames field of GstVideoTimeCodeInterval |

Since: 1.12

### gst_video_time_code_interval_clear ()

    void
    gst_video_time_code_interval_clear (GstVideoTimeCodeInterval *tc);

Initializes `tc` with empty/zero/NULL values.

#### Parameters

tc | a GstVideoTimeCodeInterval |

Since: 1.12

### gst_video_time_code_interval_copy ()

    GstVideoTimeCodeInterval *
    gst_video_time_code_interval_copy (const GstVideoTimeCodeInterval *tc);

#### Parameters

tc | a GstVideoTimeCodeInterval |

#### Returns

a new GstVideoTimeCodeInterval with the same values as `tc` .

Since: 1.12

### gst_video_time_code_interval_free ()

    void
    gst_video_time_code_interval_free (GstVideoTimeCodeInterval *tc);

Frees `tc` .

#### Parameters

tc | a GstVideoTimeCodeInterval |

Since: 1.12

## Types and Values

### struct GstVideoAlignment

    struct GstVideoAlignment {
      guint padding_top;
      guint padding_bottom;
      guint padding_left;
      guint padding_right;
      guint stride_align[GST_VIDEO_MAX_PLANES];
    };

Extra alignment parameters for the memory of video buffers. This structure is usually used to configure the bufferpool if it supports the GST_BUFFER_POOL_OPTION_VIDEO_ALIGNMENT.

#### Members

guint `padding_top`; | extra pixels on the top |
guint `padding_bottom`; | extra pixels on the bottom |
guint `padding_left`; | extra pixels on the left side |
guint `padding_right`; | extra pixels on the right side |
guint `stride_align`[GST_VIDEO_MAX_PLANES]; | array with extra alignment requirements for the strides |

### GST_META_TAG_VIDEO_STR

    #define GST_META_TAG_VIDEO_STR "video"

This metadata is relevant for video streams.

Since: 1.2

### GST_META_TAG_VIDEO_ORIENTATION_STR

    #define GST_META_TAG_VIDEO_ORIENTATION_STR "orientation"

This metadata stays relevant as long as video orientation is unchanged.

Since: 1.2

### GST_META_TAG_VIDEO_SIZE_STR

    #define GST_META_TAG_VIDEO_SIZE_STR "size"

This metadata stays relevant as long as video size is unchanged.

Since: 1.2

### GST_META_TAG_VIDEO_COLORSPACE_STR

    #define GST_META_TAG_VIDEO_COLORSPACE_STR "colorspace"

This metadata stays relevant as long as video colorspace is unchanged.

Since: 1.2

### enum GstVideoOrientationMethod

The different video orientation methods.

#### Members

GST_VIDEO_ORIENTATION_IDENTITY | Identity (no rotation) |
GST_VIDEO_ORIENTATION_90R | Rotate clockwise 90 degrees |
GST_VIDEO_ORIENTATION_180 | Rotate 180 degrees |
GST_VIDEO_ORIENTATION_90L | Rotate counter-clockwise 90 degrees |
GST_VIDEO_ORIENTATION_HORIZ | Flip horizontally |
GST_VIDEO_ORIENTATION_VERT | Flip vertically |
GST_VIDEO_ORIENTATION_UL_LR | Flip across upper left/lower right diagonal |
GST_VIDEO_ORIENTATION_UR_LL | Flip across upper right/lower left diagonal |
GST_VIDEO_ORIENTATION_AUTO | Select flip method based on image-orientation tag |
GST_VIDEO_ORIENTATION_CUSTOM | Current status depends on plugin internal setup |

Since: 1.10

### enum GstVideoFormat

Enum value describing the most common video formats.

#### Members

GST_VIDEO_FORMAT_UNKNOWN | Unknown or unset video format id |
GST_VIDEO_FORMAT_ENCODED | Encoded video format. Only ever use that in caps for special video formats in combination with non-system memory GstCapsFeatures where it does not make sense to specify a real video format. |
GST_VIDEO_FORMAT_I420 | planar 4:2:0 YUV |
GST_VIDEO_FORMAT_YV12 | planar 4:2:0 YVU (like I420 but UV planes swapped) |
GST_VIDEO_FORMAT_YUY2 | packed 4:2:2 YUV (Y0-U0-Y1-V0 Y2-U2-Y3-V2 Y4 ...) |
GST_VIDEO_FORMAT_UYVY | packed 4:2:2 YUV (U0-Y0-V0-Y1 U2-Y2-V2-Y3 U4 ...) |
GST_VIDEO_FORMAT_AYUV | packed 4:4:4 YUV with alpha channel (A0-Y0-U0-V0 ...) |
GST_VIDEO_FORMAT_RGBx | sparse rgb packed into 32 bit, space last |
GST_VIDEO_FORMAT_BGRx | sparse reverse rgb packed into 32 bit, space last |
GST_VIDEO_FORMAT_xRGB | sparse rgb packed into 32 bit, space first |
GST_VIDEO_FORMAT_xBGR | sparse reverse rgb packed into 32 bit, space first |
GST_VIDEO_FORMAT_RGBA | rgb with alpha channel last |
GST_VIDEO_FORMAT_BGRA | reverse rgb with alpha channel last |
GST_VIDEO_FORMAT_ARGB | rgb with alpha channel first |
GST_VIDEO_FORMAT_ABGR | reverse rgb with alpha channel first |
GST_VIDEO_FORMAT_RGB | rgb |
GST_VIDEO_FORMAT_BGR | reverse rgb |
GST_VIDEO_FORMAT_Y41B | planar 4:1:1 YUV |
GST_VIDEO_FORMAT_Y42B | planar 4:2:2 YUV |
GST_VIDEO_FORMAT_YVYU | packed 4:2:2 YUV (Y0-V0-Y1-U0 Y2-V2-Y3-U2 Y4 ...) |
GST_VIDEO_FORMAT_Y444 | planar 4:4:4 YUV |
GST_VIDEO_FORMAT_v210 | packed 4:2:2 10-bit YUV, complex format |
GST_VIDEO_FORMAT_v216 | packed 4:2:2 16-bit YUV, Y0-U0-Y1-V1 order |
GST_VIDEO_FORMAT_NV12 | planar 4:2:0 YUV with interleaved UV plane |
GST_VIDEO_FORMAT_NV21 | planar 4:2:0 YUV with interleaved VU plane |
GST_VIDEO_FORMAT_GRAY8 | 8-bit grayscale |
GST_VIDEO_FORMAT_GRAY16_BE | 16-bit grayscale, most significant byte first |
GST_VIDEO_FORMAT_GRAY16_LE | 16-bit grayscale, least significant byte first |
GST_VIDEO_FORMAT_v308 | packed 4:4:4 YUV (Y-U-V ...) |
GST_VIDEO_FORMAT_RGB16 | rgb 5-6-5 bits per component |
GST_VIDEO_FORMAT_BGR16 | reverse rgb 5-6-5 bits per component |
GST_VIDEO_FORMAT_RGB15 | rgb 5-5-5 bits per component |
GST_VIDEO_FORMAT_BGR15 | reverse rgb 5-5-5 bits per component |
GST_VIDEO_FORMAT_UYVP | packed 10-bit 4:2:2 YUV (U0-Y0-V0-Y1 U2-Y2-V2-Y3 U4 ...) |
GST_VIDEO_FORMAT_A420 | planar 4:4:2:0 AYUV |
GST_VIDEO_FORMAT_RGB8P | 8-bit paletted RGB |
GST_VIDEO_FORMAT_YUV9 | planar 4:1:0 YUV |
GST_VIDEO_FORMAT_YVU9 | planar 4:1:0 YUV (like YUV9 but UV planes swapped) |
GST_VIDEO_FORMAT_IYU1 | packed 4:1:1 YUV (Cb-Y0-Y1-Cr-Y2-Y3 ...) |
GST_VIDEO_FORMAT_ARGB64 | rgb with alpha channel first, 16 bits per channel |
GST_VIDEO_FORMAT_AYUV64 | packed 4:4:4 YUV with alpha channel, 16 bits per channel (A0-Y0-U0-V0 ...) |
GST_VIDEO_FORMAT_r210 | packed 4:4:4 RGB, 10 bits per channel |
GST_VIDEO_FORMAT_I420_10BE | planar 4:2:0 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I420_10LE | planar 4:2:0 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I422_10BE | planar 4:2:2 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_I422_10LE | planar 4:2:2 YUV, 10 bits per channel |
GST_VIDEO_FORMAT_Y444_10BE | planar 4:4:4 YUV, 10 bits per channel (Since: 1.2) |
GST_VIDEO_FORMAT_Y444_10LE | planar 4:4:4 YUV, 10 bits per channel (Since: 1.2) |
GST_VIDEO_FORMAT_GBR | planar 4:4:4 RGB, 8 bits per channel (Since: 1.2) |
GST_VIDEO_FORMAT_GBR_10BE | planar 4:4:4 RGB, 10 bits per channel (Since: 1.2) |
GST_VIDEO_FORMAT_GBR_10LE | planar 4:4:4 RGB, 10 bits per channel (Since: 1.2) |
GST_VIDEO_FORMAT_NV16 | planar 4:2:2 YUV with interleaved UV plane (Since: 1.2) |
GST_VIDEO_FORMAT_NV24 | planar 4:4:4 YUV with interleaved UV plane (Since: 1.2) |
GST_VIDEO_FORMAT_NV12_64Z32 | NV12 with 64x32 tiling in zigzag pattern (Since: 1.4) |
GST_VIDEO_FORMAT_A420_10BE | planar 4:4:2:0 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_A420_10LE | planar 4:4:2:0 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_A422_10BE | planar 4:4:2:2 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_A422_10LE | planar 4:4:2:2 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_A444_10BE | planar 4:4:4:4 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_A444_10LE | planar 4:4:4:4 YUV, 10 bits per channel (Since: 1.6) |
GST_VIDEO_FORMAT_NV61 | planar 4:2:2 YUV with interleaved VU plane (Since: 1.6) |
GST_VIDEO_FORMAT_P010_10BE | planar 4:2:0 YUV with interleaved UV plane, 10 bits per channel (Since: 1.10) |
GST_VIDEO_FORMAT_P010_10LE | planar 4:2:0 YUV with interleaved UV plane, 10 bits per channel (Since: 1.10) |
GST_VIDEO_FORMAT_IYU2 | packed 4:4:4 YUV (U-Y-V ...) (Since 1.10) |
GST_VIDEO_FORMAT_VYUY | packed 4:2:2 YUV (V0-Y0-U0-Y1 V2-Y2-U2-Y3 V4 ...) |
GST_VIDEO_FORMAT_GBRA | planar 4:4:4:4 ARGB, 8 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBRA_10BE | planar 4:4:4:4 ARGB, 10 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBRA_10LE | planar 4:4:4:4 ARGB, 10 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBR_12BE | planar 4:4:4 RGB, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBR_12LE | planar 4:4:4 RGB, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBRA_12BE | planar 4:4:4:4 ARGB, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GBRA_12LE | planar 4:4:4:4 ARGB, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_I420_12BE | planar 4:2:0 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_I420_12LE | planar 4:2:0 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_I422_12BE | planar 4:2:2 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_I422_12LE | planar 4:2:2 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_Y444_12BE | planar 4:4:4 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_Y444_12LE | planar 4:4:4 YUV, 12 bits per channel (Since: 1.12) |
GST_VIDEO_FORMAT_GRAY10_LE32 | 10-bit grayscale, packed into 32bit words (2 bits padding) (Since: 1.14) |
GST_VIDEO_FORMAT_NV12_10LE32 | 10-bit variant of `GST_VIDEO_FORMAT_NV12` , packed into 32bit words (MSB 2 bits padding) (Since: 1.14) |
GST_VIDEO_FORMAT_NV16_10LE32 | 10-bit variant of `GST_VIDEO_FORMAT_NV16` , packed into 32bit words (MSB 2 bits padding) (Since: 1.14) |

### GST_VIDEO_MAX_PLANES

    #define GST_VIDEO_MAX_PLANES 4

### GST_VIDEO_MAX_COMPONENTS

    #define GST_VIDEO_MAX_COMPONENTS 4

### struct GstVideoFormatInfo

    struct GstVideoFormatInfo {
      GstVideoFormat format;
      const gchar *name;
      const gchar *description;
      GstVideoFormatFlags flags;
      guint bits;
      guint n_components;
      guint shift[GST_VIDEO_MAX_COMPONENTS];
      guint depth[GST_VIDEO_MAX_COMPONENTS];
      gint  pixel_stride[GST_VIDEO_MAX_COMPONENTS];
      guint n_planes;
      guint plane[GST_VIDEO_MAX_COMPONENTS];
      guint poffset[GST_VIDEO_MAX_COMPONENTS];
      guint w_sub[GST_VIDEO_MAX_COMPONENTS];
      guint h_sub[GST_VIDEO_MAX_COMPONENTS];

      GstVideoFormat unpack_format;
      GstVideoFormatUnpack unpack_func;
      gint pack_lines;
      GstVideoFormatPack pack_func;

      GstVideoTileMode tile_mode;
      guint tile_ws;
      guint tile_hs;
    };

Information for a video format.

#### Members

GstVideoFormat `format`; | GstVideoFormat |
const gchar *`name`; | string representation of the format |
const gchar *`description`; | use readable description of the format |
GstVideoFormatFlags `flags`; | GstVideoFormatFlags |
guint `bits`; | The number of bits used to pack data items. This can be less than 8 when multiple pixels are stored in a byte. for values > 8 multiple bytes should be read according to the endianness flag before applying the shift and mask. |
guint `n_components`; | the number of components in the video format. |
guint `shift`[GST_VIDEO_MAX_COMPONENTS]; | the number of bits to shift away to get the component data |
guint `depth`[GST_VIDEO_MAX_COMPONENTS]; | the depth in bits for each component |
gint `pixel_stride`[GST_VIDEO_MAX_COMPONENTS]; | the pixel stride of each component. This is the amount of bytes to the pixel immediately to the right. When bits < 8, the stride is expressed in bits. For 24-bit RGB, this would be 3 bytes, for example, while it would be 4 bytes for RGBx or ARGB. |
guint `n_planes`; | the number of planes for this format. The number of planes can be less than the amount of components when multiple components are packed into one plane. |
guint `plane`[GST_VIDEO_MAX_COMPONENTS]; | the plane number where a component can be found |
guint `poffset`[GST_VIDEO_MAX_COMPONENTS]; | the offset in the plane where the first pixel of the components can be found. |
guint `w_sub`[GST_VIDEO_MAX_COMPONENTS]; | subsampling factor of the width for the component. Use GST_VIDEO_SUB_SCALE to scale a width. |
guint `h_sub`[GST_VIDEO_MAX_COMPONENTS]; | subsampling factor of the height for the component. Use GST_VIDEO_SUB_SCALE to scale a height. |
GstVideoFormat `unpack_format`; | the format of the unpacked pixels. This format must have the GST_VIDEO_FORMAT_FLAG_UNPACK flag set. |
GstVideoFormatUnpack `unpack_func`; | an unpack function for this format |
gint `pack_lines`; | the amount of lines that will be packed |
GstVideoFormatPack `pack_func`; | an pack function for this format |
GstVideoTileMode `tile_mode`; | The tiling mode |
guint `tile_ws`; | The width of a tile, in bytes, represented as a shift |
guint `tile_hs`; | The height of a tile, in bytes, represented as a shift |

### enum GstVideoFormatFlags

The different video flags that a format info can have.

#### Members

GST_VIDEO_FORMAT_FLAG_YUV | The video format is YUV, components are numbered 0=Y, 1=U, 2=V. |
GST_VIDEO_FORMAT_FLAG_RGB | The video format is RGB, components are numbered 0=R, 1=G, 2=B. |
GST_VIDEO_FORMAT_FLAG_GRAY | The video is gray, there is one gray component with index 0. |
GST_VIDEO_FORMAT_FLAG_ALPHA | The video format has an alpha components with the number 3. |
GST_VIDEO_FORMAT_FLAG_LE | The video format has data stored in little endianness. |
GST_VIDEO_FORMAT_FLAG_PALETTE | The video format has a palette. The palette is stored in the second plane and indexes are stored in the first plane. |
GST_VIDEO_FORMAT_FLAG_COMPLEX | The video format has a complex layout that can't be described with the usual information in the GstVideoFormatInfo. |
GST_VIDEO_FORMAT_FLAG_UNPACK | This format can be used in a GstVideoFormatUnpack and GstVideoFormatPack function. |
GST_VIDEO_FORMAT_FLAG_TILED | The format is tiled, there is tiling information in the last plane. |

### enum GstVideoPackFlags

The different flags that can be used when packing and unpacking.

#### Members

GST_VIDEO_PACK_FLAG_NONE | No flag |
GST_VIDEO_PACK_FLAG_TRUNCATE_RANGE | When the source has a smaller depth than the target format, set the least significant bits of the target to 0. This is likely sightly faster but less accurate. When this flag is not specified, the most significant bits of the source are duplicated in the least significant bits of the destination. |
GST_VIDEO_PACK_FLAG_INTERLACED | The source is interlaced. The unpacked format will be interlaced as well with each line containing information from alternating fields. (Since 1.2) |

### GST_VIDEO_SIZE_RANGE

    #define GST_VIDEO_SIZE_RANGE "(int) [ 1, max ]"

### GST_VIDEO_FPS_RANGE

    #define GST_VIDEO_FPS_RANGE "(fraction) [ 0, max ]"

### GST_VIDEO_FORMATS_ALL

    #define             GST_VIDEO_FORMATS_ALL

### enum GstVideoColorRange

Possible color range values. These constants are defined for 8 bit color values and can be scaled for other bit depths.

#### Members

GST_VIDEO_COLOR_RANGE_UNKNOWN | unknown range |
GST_VIDEO_COLOR_RANGE_0_255 | [0..255] for 8 bit components |
GST_VIDEO_COLOR_RANGE_16_235 | [16..235] for 8 bit components. Chroma has [16..240] range. |

### enum GstVideoColorMatrix

The color matrix is used to convert between Y'PbPr and non-linear RGB (R'G'B')

#### Members

GST_VIDEO_COLOR_MATRIX_UNKNOWN | unknown matrix |
GST_VIDEO_COLOR_MATRIX_RGB | identity matrix |
GST_VIDEO_COLOR_MATRIX_FCC | FCC color matrix |
GST_VIDEO_COLOR_MATRIX_BT709 | ITU-R BT.709 color matrix |
GST_VIDEO_COLOR_MATRIX_BT601 | ITU-R BT.601 color matrix |
GST_VIDEO_COLOR_MATRIX_SMPTE240M | SMPTE 240M color matrix |
GST_VIDEO_COLOR_MATRIX_BT2020 | ITU-R BT.2020 color matrix. Since: 1.6 |

### enum GstVideoColorPrimaries

The color primaries define the how to transform linear RGB values to and from the CIE XYZ colorspace.

#### Members

GST_VIDEO_COLOR_PRIMARIES_UNKNOWN | unknown color primaries |
GST_VIDEO_COLOR_PRIMARIES_BT709 | BT709 primaries |
GST_VIDEO_COLOR_PRIMARIES_BT470M | BT470M primaries |
GST_VIDEO_COLOR_PRIMARIES_BT470BG | BT470BG primaries |
GST_VIDEO_COLOR_PRIMARIES_SMPTE170M | SMPTE170M primaries |
GST_VIDEO_COLOR_PRIMARIES_SMPTE240M | SMPTE240M primaries |
GST_VIDEO_COLOR_PRIMARIES_FILM | Generic film |
GST_VIDEO_COLOR_PRIMARIES_BT2020 | BT2020 primaries. Since: 1.6 |
GST_VIDEO_COLOR_PRIMARIES_ADOBERGB | Adobe RGB primaries. Since: 1.8 |

### enum GstVideoTransferFunction

The video transfer function defines the formula for converting between non-linear RGB (R'G'B') and linear RGB

#### Members

GST_VIDEO_TRANSFER_UNKNOWN | unknown transfer function |
GST_VIDEO_TRANSFER_GAMMA10 | linear RGB, gamma 1.0 curve |
GST_VIDEO_TRANSFER_GAMMA18 | Gamma 1.8 curve |
GST_VIDEO_TRANSFER_GAMMA20 | Gamma 2.0 curve |
GST_VIDEO_TRANSFER_GAMMA22 | Gamma 2.2 curve |
GST_VIDEO_TRANSFER_BT709 | Gamma 2.2 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_SMPTE240M | Gamma 2.2 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_SRGB | Gamma 2.4 curve with a linear segment in the lower range |
GST_VIDEO_TRANSFER_GAMMA28 | Gamma 2.8 curve |
GST_VIDEO_TRANSFER_LOG100 | Logarithmic transfer characteristic 100:1 range |
GST_VIDEO_TRANSFER_LOG316 | Logarithmic transfer characteristic 316.22777:1 range |
GST_VIDEO_TRANSFER_BT2020_12 | Gamma 2.2 curve with a linear segment in the lower range. Used for BT.2020 with 12 bits per component. Since: 1.6 |
GST_VIDEO_TRANSFER_ADOBERGB | Gamma 2.19921875. Since: 1.8 |

### GstVideoColorimetry

    typedef struct {
      GstVideoColorRange        range;
      GstVideoColorMatrix       matrix;
      GstVideoTransferFunction  transfer;
      GstVideoColorPrimaries    primaries;
    } GstVideoColorimetry;

Structure describing the color info.

#### Members

GstVideoColorRange `range`; | the color range. This is the valid range for the samples. It is used to convert the samples to Y'PbPr values. |
GstVideoColorMatrix `matrix`; | the color matrix. Used to convert between Y'PbPr and non-linear RGB (R'G'B') |
GstVideoTransferFunction `transfer`; | the transfer function. used to convert between R'G'B' and RGB |
GstVideoColorPrimaries `primaries`; | color primaries. used to convert between R'G'B' and CIE XYZ |

### GST_VIDEO_COLORIMETRY_BT2020

    #define GST_VIDEO_COLORIMETRY_BT2020      "bt2020"

### GST_VIDEO_COLORIMETRY_BT601

    #define GST_VIDEO_COLORIMETRY_BT601       "bt601"

### GST_VIDEO_COLORIMETRY_BT709

    #define GST_VIDEO_COLORIMETRY_BT709       "bt709"

### GST_VIDEO_COLORIMETRY_SMPTE240M

    #define GST_VIDEO_COLORIMETRY_SMPTE240M   "smpte240m"

### GST_VIDEO_COLORIMETRY_SRGB

    #define GST_VIDEO_COLORIMETRY_SRGB        "sRGB"

### struct GstVideoInfo

    struct GstVideoInfo {
      const GstVideoFormatInfo *finfo;

      GstVideoInterlaceMode     interlace_mode;
      GstVideoFlags             flags;
      gint                      width;
      gint                      height;
      gsize                     size;
      gint                      views;

      GstVideoChromaSite        chroma_site;
      GstVideoColorimetry       colorimetry;

      gint                      par_n;
      gint                      par_d;
      gint                      fps_n;
      gint                      fps_d;

      gsize                     offset[GST_VIDEO_MAX_PLANES];
      gint                      stride[GST_VIDEO_MAX_PLANES];

      /* Union preserves padded struct size for backwards compat
       * Consumer code should use the accessor macros for fields */
      union {
        struct {
          GstVideoMultiviewMode     multiview_mode;
          GstVideoMultiviewFlags    multiview_flags;
          GstVideoFieldOrder        field_order;
        } abi;
    };

Information describing image properties. This information can be filled in from GstCaps with `gst_video_info_from_caps()`. The information is also used to store the specific video info when mapping a video frame with `gst_video_frame_map()`.

Use the provided macros to access the info in this structure.

#### Members

const GstVideoFormatInfo *`finfo`; | the format info of the video |
GstVideoInterlaceMode `interlace_mode`; | the interlace mode |
GstVideoFlags `flags`; | additional video flags |
gint `width`; | the width of the video |
gint `height`; | the height of the video |
gsize `size`; | the default size of one frame |
gint `views`; | the number of views for multiview video |
GstVideoChromaSite `chroma_site`; | a GstVideoChromaSite. |
GstVideoColorimetry `colorimetry`; | the colorimetry info |
gint `par_n`; | the pixel-aspect-ratio numerator |
gint `par_d`; | the pixel-aspect-ratio demnominator |
gint `fps_n`; | the framerate numerator |
gint `fps_d`; | the framerate demnominator |
gsize `offset`[GST_VIDEO_MAX_PLANES]; | offsets of the planes |
gint `stride`[GST_VIDEO_MAX_PLANES]; | strides of the planes |

### enum GstVideoInterlaceMode

The possible values of the GstVideoInterlaceMode describing the interlace mode of the stream.

#### Members

GST_VIDEO_INTERLACE_MODE_PROGRESSIVE | all frames are progressive |
GST_VIDEO_INTERLACE_MODE_INTERLEAVED | 2 fields are interleaved in one video frame. Extra buffer flags describe the field order. |
GST_VIDEO_INTERLACE_MODE_MIXED | frames contains both interlaced and progressive video, the buffer flags describe the frame and fields. |
GST_VIDEO_INTERLACE_MODE_FIELDS | 2 fields are stored in one buffer, use the frame ID to get access to the required field. For multiview (the 'views' property > 1) the fields of view N can be found at frame ID (N * 2) and (N * 2) + 1. Each field has only half the amount of lines as noted in the height property. This mode requires multiple GstVideoMeta metadata to describe the fields. |

### enum GstVideoFieldOrder

Field order of interlaced content. This is only valid for interlace-mode=interleaved and not interlace-mode=mixed. In the case of mixed or GST_VIDEO_FIELD_ORDER_UNKOWN, the field order is signalled via buffer flags.

#### Members

GST_VIDEO_FIELD_ORDER_UNKNOWN | unknown field order for interlaced content. The actual field order is signalled via buffer flags. |
GST_VIDEO_FIELD_ORDER_TOP_FIELD_FIRST | top field is first |
GST_VIDEO_FIELD_ORDER_BOTTOM_FIELD_FIRST | bottom field is first |

Since: 1.12

### enum GstVideoMultiviewMode

All possible stereoscopic 3D and multiview representations. In conjunction with GstVideoMultiviewFlags, describes how multiview content is being transported in the stream.

#### Members

GST_VIDEO_MULTIVIEW_MODE_NONE | A special value indicating no multiview information. Used in GstVideoInfo and other places to indicate that no specific multiview handling has been requested or provided. This value is never carried on caps. |
GST_VIDEO_MULTIVIEW_MODE_MONO | All frames are monoscopic. |
GST_VIDEO_MULTIVIEW_MODE_LEFT | All frames represent a left-eye view. |
GST_VIDEO_MULTIVIEW_MODE_RIGHT | All frames represent a right-eye view. |
GST_VIDEO_MULTIVIEW_MODE_SIDE_BY_SIDE | Left and right eye views are provided in the left and right half of the frame respectively. |
GST_VIDEO_MULTIVIEW_MODE_SIDE_BY_SIDE_QUINCUNX | Left and right eye views are provided in the left and right half of the frame, but have been sampled using quincunx method, with half-pixel offset between the 2 views. |
GST_VIDEO_MULTIVIEW_MODE_COLUMN_INTERLEAVED | Alternating vertical columns of pixels represent the left and right eye view respectively. |
GST_VIDEO_MULTIVIEW_MODE_ROW_INTERLEAVED | Alternating horizontal rows of pixels represent the left and right eye view respectively. |
GST_VIDEO_MULTIVIEW_MODE_TOP_BOTTOM | The top half of the frame contains the left eye, and the bottom half the right eye. |
GST_VIDEO_MULTIVIEW_MODE_CHECKERBOARD | Pixels are arranged with alternating pixels representing left and right eye views in a checkerboard fashion. |
GST_VIDEO_MULTIVIEW_MODE_FRAME_BY_FRAME | Left and right eye views are provided in separate frames alternately. |
GST_VIDEO_MULTIVIEW_MODE_MULTIVIEW_FRAME_BY_FRAME | Multiple independent views are provided in separate frames in sequence. This method only applies to raw video buffers at the moment. Specific view identification is via the GstVideoMultiviewMeta and GstVideoMeta(s) on raw video buffers. |
GST_VIDEO_MULTIVIEW_MODE_SEPARATED | Multiple views are provided as separate GstMemory framebuffers attached to each GstBuffer, described by the GstVideoMultiviewMeta and GstVideoMeta(s) |

### enum GstVideoMultiviewFramePacking

GstVideoMultiviewFramePacking represents the subset of GstVideoMultiviewMode values that can be applied to any video frame without needing extra metadata. It can be used by elements that provide a property to override the multiview interpretation of a video stream when the video doesn't contain any markers.

This enum is used (for example) on playbin, to re-interpret a played video stream as a stereoscopic video. The individual enum values are equivalent to and have the same value as the matching GstVideoMultiviewMode.

#### Members

GST_VIDEO_MULTIVIEW_FRAME_PACKING_NONE | A special value indicating no frame packing info. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_MONO | All frames are monoscopic. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_LEFT | All frames represent a left-eye view. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_RIGHT | All frames represent a right-eye view. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_SIDE_BY_SIDE | Left and right eye views are provided in the left and right half of the frame respectively. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_SIDE_BY_SIDE_QUINCUNX | Left and right eye views are provided in the left and right half of the frame, but have been sampled using quincunx method, with half-pixel offset between the 2 views. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_COLUMN_INTERLEAVED | Alternating vertical columns of pixels represent the left and right eye view respectively. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_ROW_INTERLEAVED | Alternating horizontal rows of pixels represent the left and right eye view respectively. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_TOP_BOTTOM | The top half of the frame contains the left eye, and the bottom half the right eye. |
GST_VIDEO_MULTIVIEW_FRAME_PACKING_CHECKERBOARD | Pixels are arranged with alternating pixels representing left and right eye views in a checkerboard fashion. |

### enum GstVideoMultiviewFlags

GstVideoMultiviewFlags are used to indicate extra properties of a stereo/multiview stream beyond the frame layout and buffer mapping that is conveyed in the GstMultiviewMode.

#### Members

GST_VIDEO_MULTIVIEW_FLAGS_NONE | No flags |
GST_VIDEO_MULTIVIEW_FLAGS_RIGHT_VIEW_FIRST | For stereo streams, the normal arrangement of left and right views is reversed. |
GST_VIDEO_MULTIVIEW_FLAGS_LEFT_FLIPPED | The left view is vertically mirrored. |
GST_VIDEO_MULTIVIEW_FLAGS_LEFT_FLOPPED | The left view is horizontally mirrored. |
GST_VIDEO_MULTIVIEW_FLAGS_RIGHT_FLIPPED | The right view is vertically mirrored. |
GST_VIDEO_MULTIVIEW_FLAGS_RIGHT_FLOPPED | The right view is horizontally mirrored. |
GST_VIDEO_MULTIVIEW_FLAGS_HALF_ASPECT | For frame-packed multiview modes, indicates that the individual views have been encoded with half the true width or height and should be scaled back up for display. This flag is used for overriding input layout interpretation by adjusting pixel-aspect-ratio. For side-by-side, column interleaved or checkerboard packings, the pixel width will be doubled. For row interleaved and top-bottom encodings, pixel height will be doubled. |
GST_VIDEO_MULTIVIEW_FLAGS_MIXED_MONO | The video stream contains both mono and multiview portions, signalled on each buffer by the absence or presence of the `GST_VIDEO_BUFFER_FLAG_MULTIPLE_VIEW` buffer flag. |

### enum GstVideoFlags

Extra video flags

#### Members

GST_VIDEO_FLAG_NONE | no flags |
GST_VIDEO_FLAG_VARIABLE_FPS | a variable fps is selected, fps_n and fps_d denote the maximum fps of the video |
GST_VIDEO_FLAG_PREMULTIPLIED_ALPHA | Each color has been scaled by the alpha value. |

### struct GstVideoFrame

    struct GstVideoFrame {
      GstVideoInfo info;
      GstVideoFrameFlags flags;

      GstBuffer *buffer;
      gpointer   meta;
      gint       id;

      gpointer   data[GST_VIDEO_MAX_PLANES];
      GstMapInfo map[GST_VIDEO_MAX_PLANES];
    };

A video frame obtained from `gst_video_frame_map()`

#### Members

GstVideoInfo `info`; | the GstVideoInfo |
GstVideoFrameFlags `flags`; | GstVideoFrameFlags for the frame |
GstBuffer *`buffer`; | the mapped buffer |
gpointer `meta`; | pointer to metadata if any |
gint `id`; | id of the mapped frame. the id can for example be used to indentify the frame in case of multiview video. |
gpointer `data`[GST_VIDEO_MAX_PLANES]; | pointers to the plane data |
GstMapInfo `map`[GST_VIDEO_MAX_PLANES]; | mappings of the planes |

### enum GstVideoFrameFlags

Extra video frame flags

#### Members

GST_VIDEO_FRAME_FLAG_NONE | no flags |
GST_VIDEO_FRAME_FLAG_INTERLACED | The video frame is interlaced. In mixed interlace-mode, this flag specifies if the frame is interlaced or progressive. |
GST_VIDEO_FRAME_FLAG_TFF | The video frame has the top field first |
GST_VIDEO_FRAME_FLAG_RFF | The video frame has the repeat flag |
GST_VIDEO_FRAME_FLAG_ONEFIELD | The video frame has one field |
GST_VIDEO_FRAME_FLAG_MULTIPLE_VIEW | The video contains one or more non-mono views |
GST_VIDEO_FRAME_FLAG_FIRST_IN_BUNDLE | The video frame is the first in a set of corresponding views provided as sequential frames. |

### enum GstVideoFrameMapFlags

Additional mapping flags for `gst_video_frame_map()`.

#### Members

GST_VIDEO_FRAME_MAP_FLAG_NO_REF | Don't take another reference of the buffer and store it in the GstVideoFrame. This makes sure that the buffer stays writable while the frame is mapped, but requires that the buffer reference stays valid until the frame is unmapped again. |
GST_VIDEO_FRAME_MAP_FLAG_LAST | Offset to define more flags |

Since: 1.6

### enum GstVideoBufferFlags

Additional video buffer flags. These flags can potentially be used on any buffers carrying video data - even encoded data.

Note that these are only valid for GstCaps of type: video/... They can conflict with other extended buffer flags.

#### Members

GST_VIDEO_BUFFER_FLAG_INTERLACED | If the GstBuffer is interlaced. In mixed interlace-mode, this flags specifies if the frame is interlaced or progressive. |
GST_VIDEO_BUFFER_FLAG_TFF | If the GstBuffer is interlaced, then the first field in the video frame is the top field. If unset, the bottom field is first. |
GST_VIDEO_BUFFER_FLAG_RFF | If the GstBuffer is interlaced, then the first field (as defined by the `GST_VIDEO_BUFFER_TFF` flag setting) is repeated. |
GST_VIDEO_BUFFER_FLAG_ONEFIELD | If the GstBuffer is interlaced, then only the first field (as defined by the `GST_VIDEO_BUFFER_TFF` flag setting) is to be displayed. |
GST_VIDEO_BUFFER_FLAG_MULTIPLE_VIEW | The GstBuffer contains one or more specific views, such as left or right eye view. This flags is set on any buffer that contains non-mono content - even for streams that contain only a single viewpoint. In mixed mono / non-mono streams, the absense of the flag marks mono buffers. |
GST_VIDEO_BUFFER_FLAG_FIRST_IN_BUNDLE | When conveying stereo/multiview content with frame-by-frame methods, this flag marks the first buffer in a bundle of frames that belong together. |
GST_VIDEO_BUFFER_FLAG_LAST | Offset to define more flags |

### enum GstVideoTileType

Enum value describing the most common tiling types.

#### Members

GST_VIDEO_TILE_TYPE_INDEXED | Tiles are indexed. Use `gst_video_tile_get_index()` to retrieve the tile at the requested coordinates. |

### enum GstVideoTileMode

Enum value describing the available tiling modes.

#### Members

GST_VIDEO_TILE_MODE_UNKNOWN | Unknown or unset tile mode |
GST_VIDEO_TILE_MODE_ZFLIPZ_2X2 | Every four adjacent blocks - two horizontally and two vertically are grouped together and are located in memory in Z or flipped Z order. In case of odd rows, the last row of blocks is arranged in linear order. |

### GstVideoConverter

    typedef struct _GstVideoConverter GstVideoConverter;

### enum GstVideoAlphaMode

Different alpha modes.

#### Members

GST_VIDEO_ALPHA_MODE_COPY | When input and output have alpha, it will be copied. When the input has no alpha, alpha will be set to GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE |
GST_VIDEO_ALPHA_MODE_SET | set all alpha to GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE |
GST_VIDEO_ALPHA_MODE_MULT | multiply all alpha with GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE. When the input format has no alpha but the output format has, the alpha value will be set to GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE |

Since: 1.6

### enum GstVideoChromaMode

Different chroma downsampling and upsampling modes

#### Members

GST_VIDEO_CHROMA_MODE_FULL | do full chroma up and down sampling |
GST_VIDEO_CHROMA_MODE_UPSAMPLE_ONLY | only perform chroma upsampling |
GST_VIDEO_CHROMA_MODE_DOWNSAMPLE_ONLY | only perform chroma downsampling |
GST_VIDEO_CHROMA_MODE_NONE | disable chroma resampling |

Since: 1.6

### enum GstVideoGammaMode

#### Members

GST_VIDEO_GAMMA_MODE_NONE | disable gamma handling |
GST_VIDEO_GAMMA_MODE_REMAP | convert between input and output gamma Different gamma conversion modes |

Since: 1.6

### enum GstVideoMatrixMode

Different color matrix conversion modes

#### Members

GST_VIDEO_MATRIX_MODE_FULL | do conversion between color matrices |
GST_VIDEO_MATRIX_MODE_INPUT_ONLY | use the input color matrix to convert to and from R'G'B |
GST_VIDEO_MATRIX_MODE_OUTPUT_ONLY | use the output color matrix to convert to and from R'G'B |
GST_VIDEO_MATRIX_MODE_NONE | disable color matrix conversion. |

Since: 1.6

### enum GstVideoPrimariesMode

Different primaries conversion modes

#### Members

GST_VIDEO_PRIMARIES_MODE_NONE | disable conversion between primaries |
GST_VIDEO_PRIMARIES_MODE_MERGE_ONLY | do conversion between primaries only when it can be merged with color matrix conversion. |
GST_VIDEO_PRIMARIES_MODE_FAST | fast conversion between primaries |

Since: 1.6

### GST_VIDEO_CONVERTER_OPT_ALPHA_MODE

    #define GST_VIDEO_CONVERTER_OPT_ALPHA_MODE   "GstVideoConverter.alpha-mode"

GST_TYPE_VIDEO_ALPHA_MODE, the alpha mode to use. Default is GST_VIDEO_ALPHA_MODE_COPY.

### GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE

    #define GST_VIDEO_CONVERTER_OPT_ALPHA_VALUE   "GstVideoConverter.alpha-value"

G_TYPE_DOUBLE, the alpha color value to use. Default to 1.0

### GST_VIDEO_CONVERTER_OPT_BORDER_ARGB

    #define GST_VIDEO_CONVERTER_OPT_BORDER_ARGB   "GstVideoConverter.border-argb"

G_TYPE_UINT, the border color to use if GST_VIDEO_CONVERTER_OPT_FILL_BORDER is set to `TRUE`. The color is in ARGB format. Default 0xff000000

### GST_VIDEO_CONVERTER_OPT_CHROMA_MODE

    #define GST_VIDEO_CONVERTER_OPT_CHROMA_MODE   "GstVideoConverter.chroma-mode"

GST_TYPE_VIDEO_CHROMA_MODE, set the chroma resample mode subsampled formats. Default is GST_VIDEO_CHROMA_MODE_FULL.

### GST_VIDEO_CONVERTER_OPT_CHROMA_RESAMPLER_METHOD

    #define GST_VIDEO_CONVERTER_OPT_CHROMA_RESAMPLER_METHOD   "GstVideoConverter.chroma-resampler-method"

GST_TYPE_RESAMPLER_METHOD, The resampler method to use for chroma resampling. Other options for the resampler can be used, see the GstResampler. Default is GST_RESAMPLER_METHOD_LINEAR

### GST_VIDEO_CONVERTER_OPT_DEST_HEIGHT

    #define GST_VIDEO_CONVERTER_OPT_DEST_HEIGHT   "GstVideoConverter.dest-height"

G_TYPE_INT, height in the destination frame, default destination height

### GST_VIDEO_CONVERTER_OPT_DEST_WIDTH

    #define GST_VIDEO_CONVERTER_OPT_DEST_WIDTH   "GstVideoConverter.dest-width"

G_TYPE_INT, width in the destination frame, default destination width

### GST_VIDEO_CONVERTER_OPT_DEST_X

    #define GST_VIDEO_CONVERTER_OPT_DEST_X   "GstVideoConverter.dest-x"

G_TYPE_INT, x position in the destination frame, default 0

### GST_VIDEO_CONVERTER_OPT_DEST_Y

    #define GST_VIDEO_CONVERTER_OPT_DEST_Y   "GstVideoConverter.dest-y"

G_TYPE_INT, y position in the destination frame, default 0

### GST_VIDEO_CONVERTER_OPT_DITHER_METHOD

    #define GST_VIDEO_CONVERTER_OPT_DITHER_METHOD   "GstVideoConverter.dither-method"

GST_TYPE_VIDEO_DITHER_METHOD, The dither method to use when changing bit depth. Default is GST_VIDEO_DITHER_BAYER.

### GST_VIDEO_CONVERTER_OPT_DITHER_QUANTIZATION

    #define GST_VIDEO_CONVERTER_OPT_DITHER_QUANTIZATION   "GstVideoConverter.dither-quantization"

G_TYPE_UINT, The quantization amount to dither to. Components will be quantized to multiples of this value. Default is 1

### GST_VIDEO_CONVERTER_OPT_FILL_BORDER

    #define GST_VIDEO_CONVERTER_OPT_FILL_BORDER   "GstVideoConverter.fill-border"

G_TYPE_BOOLEAN, if the destination rectangle does not fill the complete destination image, render a border with GST_VIDEO_CONVERTER_OPT_BORDER_ARGB. Otherwise the unusded pixels in the destination are untouched. Default `TRUE`.

### GST_VIDEO_CONVERTER_OPT_GAMMA_MODE

    #define GST_VIDEO_CONVERTER_OPT_GAMMA_MODE   "GstVideoConverter.gamma-mode"

GST_TYPE_VIDEO_GAMMA_MODE, set the gamma mode. Default is GST_VIDEO_GAMMA_MODE_NONE.

### GST_VIDEO_CONVERTER_OPT_MATRIX_MODE

    #define GST_VIDEO_CONVERTER_OPT_MATRIX_MODE   "GstVideoConverter.matrix-mode"

GST_TYPE_VIDEO_MATRIX_MODE, set the color matrix conversion mode for converting between Y'PbPr and non-linear RGB (R'G'B'). Default is GST_VIDEO_MATRIX_MODE_FULL.

### GST_VIDEO_CONVERTER_OPT_PRIMARIES_MODE

    #define GST_VIDEO_CONVERTER_OPT_PRIMARIES_MODE   "GstVideoConverter.primaries-mode"

GST_TYPE_VIDEO_PRIMARIES_MODE, set the primaries conversion mode. Default is GST_VIDEO_PRIMARIES_MODE_NONE.

### GST_VIDEO_CONVERTER_OPT_RESAMPLER_METHOD

    #define GST_VIDEO_CONVERTER_OPT_RESAMPLER_METHOD   "GstVideoConverter.resampler-method"

GST_TYPE_RESAMPLER_METHOD, The resampler method to use for resampling. Other options for the resampler can be used, see the GstResampler. Default is GST_RESAMPLER_METHOD_CUBIC

### GST_VIDEO_CONVERTER_OPT_RESAMPLER_TAPS

    #define GST_VIDEO_CONVERTER_OPT_RESAMPLER_TAPS   "GstVideoConverter.resampler-taps"

G_TYPE_UINT, The number of taps for the resampler. Default is 0: let the resampler choose a good value.

### GST_VIDEO_CONVERTER_OPT_SRC_HEIGHT

    #define GST_VIDEO_CONVERTER_OPT_SRC_HEIGHT   "GstVideoConverter.src-height"

G_TYPE_INT, source height to convert, default source height

### GST_VIDEO_CONVERTER_OPT_SRC_WIDTH

    #define GST_VIDEO_CONVERTER_OPT_SRC_WIDTH   "GstVideoConverter.src-width"

G_TYPE_INT, source width to convert, default source width

### GST_VIDEO_CONVERTER_OPT_SRC_X

    #define GST_VIDEO_CONVERTER_OPT_SRC_X   "GstVideoConverter.src-x"

G_TYPE_INT, source x position to start conversion, default 0

### GST_VIDEO_CONVERTER_OPT_SRC_Y

    #define GST_VIDEO_CONVERTER_OPT_SRC_Y   "GstVideoConverter.src-y"

G_TYPE_INT, source y position to start conversion, default 0

### GST_VIDEO_MULTIVIEW_MAX_FRAME_PACKING

    #define GST_VIDEO_MULTIVIEW_MAX_FRAME_PACKING GST_VIDEO_MULTIVIEW_FRAME_PACKING_CHECKERBOARD

### struct GstVideoTimeCode

    struct GstVideoTimeCode {
      GstVideoTimeCodeConfig config;

      guint hours;
      guint minutes;
      guint seconds;
      guint frames;
      guint field_count;
    };

`field_count` must be 0 for progressive video and 1 or 2 for interlaced.

A representation of a SMPTE time code.

`hours` must be positive and less than 24. Will wrap around otherwise. `minutes` and `seconds` must be positive and less than 60. `frames` must be less than or equal to `config.fps_n` / `config.fps_d` These values are *NOT* automatically normalized.

#### Members

GstVideoTimeCodeConfig `config`; | the corresponding GstVideoTimeCodeConfig |
guint `hours`; | the hours field of GstVideoTimeCode |
guint `minutes`; | the minutes field of GstVideoTimeCode |
guint `seconds`; | the seconds field of GstVideoTimeCode |
guint `frames`; | the frames field of GstVideoTimeCode |
guint `field_count`; | Interlaced video field count |

Since: 1.10

### struct GstVideoTimeCodeConfig

    struct GstVideoTimeCodeConfig {
      guint fps_n;
      guint fps_d;
      GstVideoTimeCodeFlags flags;
      GDateTime *latest_daily_jam;
    };

Supported frame rates: 30000/1001, 60000/1001 (both with and without drop frame), and integer frame rates e.g. 25/1, 30/1, 50/1, 60/1.

The configuration of the time code.

#### Members

guint `fps_n`; | Numerator of the frame rate |
guint `fps_d`; | Denominator of the frame rate |
GstVideoTimeCodeFlags `flags`; | the corresponding GstVideoTimeCodeFlags |
GDateTime *`latest_daily_jam`; | The latest daily jam information, if present, or NULL |

Since: 1.10

### enum GstVideoTimeCodeFlags

Flags related to the time code information. For drop frame, only 30000/1001 and 60000/1001 frame rates are supported.

#### Members

GST_VIDEO_TIME_CODE_FLAGS_NONE | No flags |
GST_VIDEO_TIME_CODE_FLAGS_DROP_FRAME | Whether we have drop frame rate |
GST_VIDEO_TIME_CODE_FLAGS_INTERLACED | Whether we have interlaced video |

Since: 1.10

### struct GstVideoTimeCodeInterval

    struct GstVideoTimeCodeInterval {
      guint hours;
      guint minutes;
      guint seconds;
      guint frames;
    };

A representation of a difference between two GstVideoTimeCode instances. Will not necessarily correspond to a real timecode (e.g. 00:00:10;00)

#### Members

guint `hours`; | the hours field of GstVideoTimeCodeInterval |
guint `minutes`; | the minutes field of GstVideoTimeCodeInterval |
guint `seconds`; | the seconds field of GstVideoTimeCodeInterval |
guint `frames`; | the frames field of GstVideoTimeCodeInterval |

Since: 1.12